#!/bin/bash

# rename_mnf_ftp_avhrr_finv2.sh
# 1981/09/01 ~ 2012/01/04
# Author: Chunying Liu
# Created date: 2012/01/19

CreateMNF() {
 local CMErr='none'
 if [ -s $1 ];then
   local MD5Ar=( $(md5sum --binary $1 |tr -s ' ' |tr -d '\*') )
   if [ ${#MD5Ar[@]} -eq 2 ];then
     local FSZ=$(find ${1%/*}"/" -name "${1##*/}" -printf "%s")
     if [ ${#FSZ} -gt 0 ];then
       echo ${1##*/},${MD5Ar[0]},$FSZ > $1".mnf"
     else
       CMErr="FileSizeError"
     fi
   else
     CMErr="ChkSumError"
   fi
 else
   CMErr="FileNOTFound"
 fi
 if [ $CMErr != 'none' ];then
   echo CreateMNF Failed: $CMErr
 fi
}


TMstop=20120105
#TM=20120101

#TMstop=19810903
TM=20120101

#TM=19810901

echo $TM

iyrs=`expr $TM | cut -c1-4`
iyrmid0=0000

echo $iyrs

while [ "$TM" -le "$TMstop" ]
do

  if [ "$iyrs" -ne "$iyrmid0" ]
  then
  echo "rename year: " $iyrs  
  cd /raid2/sstday/$iyrs/netcdf/NOMADS/AVHRR_finv2  
  rm  oisst_daily_avhrr*    
  gunzip *.gz  
  fi
  

CreateMNF /raid2/sstday/$iyrs/netcdf/NOMADS/AVHRR_finv2/avhrr-only-v2.$TM.nc

# sftp to Archive

rm ftp_archive

echo "open gulp2.ncdc.noaa.gov" >> ftp_archive 
echo "user anonymous Chunying.Liu@noaa.gov" >> ftp_archive
echo "cd /pub/upload/Ingest/OISST/avhrr_only/$iyrs " >> ftp_archive
echo "put avhrr-only-v2.$TM.nc" >> ftp_archive
echo "put avhrr-only-v2.$TM.nc.mnf" >> ftp_archive
echo "quit" < ftp_archive 

ftp -n -v -i < ftp_archive


#find the next day.

iyrmid0=$iyrs
  
TM=`sh /home/cliu/shell_lib/finddate.sh $TM d+1`

iyrs=`expr $TM | cut -c1-4`
  
done 

