#! /bin/sh
# /raid2/cliu/sstdat/script/oisst_avhrr_only_data_intv2.sh

# run both bias and nobias OI in the same code
# set -x # turns on echo  for script
# set +x # turns off echo for script

# ftp all the data and generate sobs for the METOP NAVY18 AVHRR only OI run

# Chunying Liu  July 2008

################################################################################################


cd /raid2/cliu/sstday/script
 
. /usr/local/lf9562/bash_setup   # setup the Fortran lib for cron job
GASCRP='/home/rreynold/grads_lib'
PATH=$PATH:/home/cliu/netcdf/netcdf-3.6.0-p1/f90/bin
export PATH GADDIR GASCRP
export NFf90=/home/cliu/netcdf/netcdf-3.6.0-p1/f90
ulimit -s unlimited
umask 002

FTN2=/raid2/cliu/sstday/ftn              # FORTRAN CODES
#echo $FTN2



echo 'FTP data for NAVY EOT BIAS CORRECTION NOAA19 METOP INTV2 OI RUN '


#echo "Script run today to produce sobs for yesterday"

curryear=`date '+%Y'`
currmon=`date '+%m'`
today=`date '+%d'`
#echo $curryear,$currmon,$today

TMtoday=$curryear$currmon$today
#echo $TMtoday

#TMtoday=20060429

# TMstop is the last anylysis day, it is one days ago when using NCEP 1-day delay in situ data
# or one day ago when using NCDC in situ data
   
TMstop=`sh /raid/cliu/shell_lib/finddate.sh $TMtoday d-1`
#echo attempt to run $TMstop
imstop=`expr $TMstop | cut -c5-6`

#get parm for NetCDF
iyre=`expr $TMstop | cut -c1-4`
imoe=`expr $TMstop | cut -c5-6`
idae=`expr $TMstop | cut -c7-8`

# read in from last run's output file to find out the analysis date which has a successful run

TMlast=`cat /raid2/cliu/sstday/script/oi_intv2.txt`

# Theoritically SHOULD BE oi_intv2_data.txt 
# But if the data part run and oi not run. It will not trick the oi run start 
# because the oi_intv2_data.txt already changed to next day. 
# TMlast=`cat /raid2/cliu/sstday/script/oi_intv2_data.txt`
#

echo 'the last successful run date:'$TMlast


if [ "$TMlast" -ge "$TMstop" ]
then
echo Today is $TMtoday. The input data only need ftp utill $TMstop.
echo $TMstop already ftp successful.
exit
fi

# the start date of this run is 
TMmid=`sh /raid/cliu/shell_lib/finddate.sh $TMlast d+1`
#echo start run date: $TMmid

# as if it is a historic run

echo ' start ftp date' $TMmid
echo ' end  ftp  date' $TMstop

#get parm for NetCDF
iyrs=`expr $TMmid | cut -c1-4`
imos=`expr $TMmid | cut -c5-6`
idas=`expr $TMmid | cut -c7-8`

echo 'parameters for NetCDF run:' $iyrs$imos$idas'_'$iyre$imoe$idae

iyrmid=`expr $TMmid | cut -c1-4`
immid=`expr $TMmid | cut -c5-6`
idmid=`expr $TMmid | cut -c7-8`

echo $iyrmid
echo $immid
echo $idmid


#define the land mask name
#sea_mask_in='/raid2/sstday/clim/lstags.onedeg.dat'
#echo $sea_mask_in

#define the 1/4 degree land mask name
quarter_mask_in='/raid2/sstday/clim/quarter-mask-extend'
echo $quarter_mask_in

# define the input climatatology name

file_stdev_in='/raid2/sstday/clim/stdev1d-coads3-fill'
echo $file_stdev_in


while [ "$TMmid" -le "$TMstop" ]
do

echo 'Analysis date ' $TMmid

TMg=`sh /raid/cliu/oiweekly/script/finddate.sh $TMmid d-1`
echo 'First guess EOT date ' $TMg
YEARg=`echo $TMg | cut -c 1-4`

#Navy eot metop noaa19 intv2 first guess

navyeotfg=/raid2/sstday/$YEARg/eotanal/nv1718-intv2/sst4-nv1718-eot-intv2.$TMg
echo $navyeotfg

echo '############# ftp buoy ship obs.########################'

echo "**************** start time for ftp buoy ship data =" `date '+%T'`
     
# only need one day delay file if run one day delay     
     
if [ "$TMmid" -eq "$TMstop" ] 
then
     
 echo "get the one day delay data ftp://ftp.emc.ncep.noaa.gov/cmb/misc/rwr/gts.1day.dat.gz"
 
 rm ftp_buoyship_oneday
 echo "open ftp.emc.ncep.noaa.gov" > ftp_buoyship_oneday
 echo "user anonymous Chunying.Liu@noaa.gov" >> ftp_buoyship_oneday
 echo "cd /cmb/misc/rwr" >> ftp_buoyship_oneday
 echo "bin" >> ftp_buoyship_oneday
 echo "prompt" >> ftp_buoyship_oneday
 echo "get gts.1day.dat.gz" >> ftp_buoyship_oneday
 echo "quit" >> ftp_buoyship_oneday
 
 echo "************** start time for ftp buoy ship data =" `date '+%T'`

 ftp -ivn < ftp_buoyship_oneday  
 
  if [ -f  gts.1day.dat.gz ]
  then 
  echo one day delay file gts.1day.dat.gz available from FTP   

  mv gts.1day.dat.gz /raid2/sstday/$iyrmid/obs/buoyship/NCEP/ 
 
  if [ -f  /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.1day.dat ]
  then 
  rm /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.1day.dat
  fi  
  gunzip /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.1day.dat.gz  
  mv /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.1day.dat /raid2/sstday/$iyrmid/obs/buoyship/NCEP/nq.$TMmid
  else
  echo RED-STOP: one day delay file gts.1day.dat.gz is not available from FTP
    # if [ "$TMmid" -eq "$TMstop" ]
    # then
  exit
   # fi
  fi
     
fi     

# if run two day delay or more than two days delay.
if [ "$TMmid" -lt "$TMstop" ] 
then
         
 echo "get the two day delay data ftp://ftp.emc.ncep.noaa.gov/cmb/obs/gts/gts.sfcmar.partial.gz"
 echo "get last month's data ftp://ftp.emc.ncep.noaa.gov/cmb/obs/gts/gts.sfcmar.gz"
 
 rm ftp_buoyship
 echo "open ftp.emc.ncep.noaa.gov" > ftp_buoyship
 echo "user anonymous Chunying.Liu@noaa.gov" >> ftp_buoyship
 echo "cd /cmb/obs/gts" >> ftp_buoyship
 echo "bin" >> ftp_buoyship
 echo "prompt" >> ftp_buoyship
 echo "get gts.sfcmar.partial.gz" >> ftp_buoyship
 echo "get gts.sfcmar.gz" >> ftp_buoyship
 echo "quit" >> ftp_buoyship

 ftp -ivn < ftp_buoyship 
 
# if the analysis date is in the same month of one day before the run day(runday is today)
# then also need gts.sfcmar.partial.gz

if [ "$immid" -eq "$imstop" ] 
then     
    if [ -f  gts.sfcmar.partial.gz ]
    then 
    echo two day delay file gts.sfcmar.partial.gz available from FTP  
    mv  gts.sfcmar.partial.gz  /raid2/sstday/$iyrmid/obs/buoyship/NCEP/   
    gunzip /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.sfcmar.partial.gz  
    mv /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.sfcmar.partial /raid2/sstday/$iyrmid/obs/buoyship/NCEP/nq.$TMmid
    else
    echo RED-STOP:two day delay file gts.sfcmar.partial.gz is not available from FTP
    exit
    fi 
fi

# if the analysis day is a month before yesterday
# gts.sfcmar.partial.gz only have current month's data
# so also need open monthly file

if [ "$immid" -lt "$imstop" ] 
then     
    if [ -f  gts.sfcmar.gz ]
    then 
    echo last month file gts.sfcmar.gz available from FTP  
    mv  gts.sfcmar.gz  /raid2/sstday/$iyrmid/obs/buoyship/NCEP/   
    gunzip /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.sfcmar.gz  
    mv /raid2/sstday/$iyrmid/obs/buoyship/NCEP/gts.sfcmar /raid2/sstday/$iyrmid/obs/buoyship/NCEP/nq.$TMmid
    else
    echo RED-STOP:last month file gts.sfcmar.gz is not available from FTP
    exit
    fi 
fi

fi

echo "**************** end time for ftp buoy ship data =" `date '+%T'`
   

echo '############# generate buoy ship super obs.########################'

     
# empty the obs count one big file
rm /raid2/sstday/$iyrmid/obs/buoy/buoy_obs
rm /raid2/sstday/$iyrmid/obs/ship/ship_obs
   
# define the monthly input file 
file_in="/raid2/sstday/$iyrmid/obs/buoyship/NCEP/nq."$TMmid
echo $file_in

# define the buoy and ship SST obs ascii file(final clean up obs)
buoy_obs_out='/raid2/sstday/'$iyrmid'/obs/buoy/buoy.'$TMmid
echo $buoy_obs_out
ship_obs_out='/raid2/sstday/'$iyrmid'/obs/ship/ship.'$TMmid
echo $ship_obs_out

# define the buoy and ship SST grid file
buoy_grid_out='/raid2/sstday/'$iyrmid'/grads/buoy/buoy.'$TMmid
echo $buoy_grid_out
ship_grid_out='/raid2/sstday/'$iyrmid'/grads/ship/ship.'$TMmid
echo $ship_grid_out

#define the sobs output for buoy
buoy_sobs_out="/raid2/sstday/"$iyrmid"/sobs/coad/buoy/buoy."$TMmid
echo $buoy_sobs_out

#define the sobs output for ship
ship_sobs_out="/raid2/sstday/"$iyrmid"/sobs/coad/ship/ship."$TMmid
echo $ship_sobs_out

cov_buoy=0.1
cov_ship=0.05
cov_buoyship=0.0
cov_name="/raid2/cliu/sstday/script/cover.txt"
echo $cov_name

#rm /raid2/cliu/sstday/script/cover.txt

cat <<oiEOF > buoyship.parm
$quarter_mask_in
$file_stdev_in
$file_in
$navyeotfg
$ship_obs_out
$buoy_obs_out
$ship_grid_out
$buoy_grid_out
$ship_sobs_out
$buoy_sobs_out
$cov_name
$iyrmid $immid $idmid
$cov_buoy
$cov_ship
$cov_buoyship
oiEOF

 ./buoy_ship_daily_historic_firstguessclim_col.x -Wl,-T <buoyship.parm 
 stopcode=$?  
echo 'buoy_ship_daily_historic_firstguessclim_col.x: call exit ' $stopcode

coverage=`cat /raid2/cliu/sstday/script/cover.txt`
echo $coverage

export buoy_cov=${coverage:0:4}
echo $buoy_cov
export ship_cov=${coverage:5:4}
echo $ship_cov

if [ $stopcode -eq 10 ]
then

#    echo 'YELLOW-WARNING! ERROR buoy_ship_daily_historic_firstguessclim_col.x' $stopcode 
    
#     ./buoy_ship_daily_historic_firstguessclim_col.x -Wl,-T <buoyship.parm 
#     cat /raid2/cliu/sstday/script/output/buoyship_firstguessclim.out.$TMmid   
 
# generate empty buoy ship super obs so the satellite bias correction code would run  

# define the empty buoy ship file name  
  empty_buoy="/raid2/sstday/$iyrmid/sobs/coad/buoy/buoy."$TMmid
  echo $empty_buoy   
  
  empty_ship="/raid2/sstday/$iyrmid/sobs/coad/ship/ship."$TMmid
  echo $empty_ship
  
cat << oiEOF > empty_buoyship.parm
$empty_buoy
$empty_ship
$iyrmid $immid $idmid
oiEOF

     
 ./empty_buoyship.x -Wl,-T <empty_buoyship.parm 
   stopcode=$?  
echo 'empty_buoyship.x : call exit ' $stopcode

export buoy_cov=0
echo $buoy_cov
export ship_cov=0
echo $ship_cov

   if [ $stopcode -ne 1 ]
   then

    echo 'ERROR empty_buoyship.x' $stopcode
    cat emptyout_buoyship
    fi 

    if [ $stopcode -ge 100 ]
    then
    exit
    fi  
           
fi

if [ $stopcode -eq 100 ]
then
#echo 'RED-STOP! buoyship'

#     ./buoy_ship_daily_historic_firstguessclim_col.x -Wl,-T <buoyship.parm > /raid2/cliu/sstday/script/output/buoyship_firstguessclim.out.$TMmid
#     cat /raid2/cliu/sstday/script/output/buoyship_firstguessclim.out.$TMmid 
  exit
fi

if [ $stopcode -ne 1 -a $stopcode -ne 10 -a $stopcode -ne 100 ]
then
  echo 'RED-STOP: buoy_ship_daily_historic_firstguessclim_col.f data error'
  exit
fi

# cat the obs number of each day to a big file
cat buoy_obs >> /raid2/sstday/$iyrmid/obs/buoy/buoy_obs
cat ship_obs >> /raid2/sstday/$iyrmid/obs/ship/ship_obs                

rm buoy_obs
rm ship_obs


echo "************** end time for run buoy ship quality control code =" `date '+%T'`


echo '############### get satellite obs ###################'

echo "************** start time for run satellite quality control code =" `date '+%T'`

# find the right date that the 3 days 6-hour files 
# all time yesterday. >20hours the day before yesterday,
# and less than 10 hours today

# in the code it get three days satellite data, actually it only need get yesterday and today before 10 hours data.

TMmid1=`sh /raid/cliu/shell_lib/finddate.sh $TMmid d-1`
TMmid2=`sh /raid/cliu/shell_lib/finddate.sh $TMmid d+1`
ddd=`sh /raid/cliu/shell_lib/ymd2yyyyddd.sh $TMmid`
ddd1=`sh /raid/cliu/shell_lib/ymd2yyyyddd.sh $TMmid1`
ddd2=`sh /raid/cliu/shell_lib/ymd2yyyyddd.sh $TMmid2`
echo $TMmid $TMmid1 $TMmid2 
echo $ddd $ddd1 $ddd2 

iyrmid1=`expr $TMmid1 | cut -c1-4`
iyrmid2=`expr $TMmid2 | cut -c1-4`
echo $iyrmid1 $iyrmid $iyrmid2


echo ############# FTP get 6-hourly navy satellite data for today #############
rm ftpsat
echo user F0087 NCDCnc18 >> ftpsat
echo cd pull  >> ftpsat
echo ls navysst.tmpobs.n19m02n18.$iyrmid.$ddd* >> ftpsat
echo ls navysst.tmpobs.n19m02n18."$iyrmid1.$ddd1".2* >> ftpsat
echo ls navysst.tmpobs.n19m02n18."$iyrmid1.$ddd1".18* >> ftpsat
echo ls navysst.tmpobs.n19m02n18."$iyrmid2.$ddd2".0* >> ftpsat

echo binary >> ftpsat
echo mget navysst.tmpobs.n19m02n18.$iyrmid.$ddd* >> ftpsat
echo mget navysst.tmpobs.n19m02n18."$iyrmid1.$ddd1".2* >> ftpsat
echo mget navysst.tmpobs.n19m02n18."$iyrmid1.$ddd1".18* >> ftpsat
echo mget navysst.tmpobs.n19m02n18."$iyrmid2.$ddd2".0* >> ftpsat

echo quit >> ftpsat

ftp -n -v -i dds.nesdis.noaa.gov < ftpsat

mv navysst.tmpobs.n19m02n18.$iyrmid.$ddd* /raid2/cliu/satellite/navy/$iyrmid
mv navysst.tmpobs.n19m02n18."$iyrmid1.$ddd1".2* /raid2/cliu/satellite/navy/$iyrmid
mv navysst.tmpobs.n19m02n18."$iyrmid1.$ddd1".18* /raid2/cliu/satellite/navy/$iyrmid
mv navysst.tmpobs.n19m02n18."$iyrmid2.$ddd2".0* /raid2/cliu/satellite/navy/$iyrmid
chgrp oisst /raid2/cliu/satellite/navy/$iyrmid/* 
chgrp oisst /raid2/cliu/satellite/navy/$iyrmid1/* 
chgrp oisst /raid2/cliu/satellite/navy/$iyrmid2/* 

# check if there are at least one satellite files available
rm sat
 ls /raid2/cliu/satellite/navy/"$iyrmid"/navysst.tmpobs.n19m02n18.$iyrmid."$ddd".* >> sat
 ls /raid2/cliu/satellite/navy/"$iyrmid1"/navysst.tmpobs.n19m02n18.$iyrmid1."$ddd1".2* >> sat
 ls /raid2/cliu/satellite/navy/"$iyrmid1"/navysst.tmpobs.n19m02n18.$iyrmid1."$ddd1".18* >> sat
 ls /raid2/cliu/satellite/navy/"$iyrmid2"/navysst.tmpobs.n19m02n18.$iyrmid2."$ddd2".0* >> sat
 
var_day=`grep $ddd sat -c` 
var_day1=`grep $ddd1 sat -c`
var_day2=`grep $ddd2 sat -c`
echo $var_day files navysst.tmpobs.n19m02n18.$iyrmid."$ddd".hhmm on the analysis day $TMmid
echo $var_day1 files navysst.tmpobs.n19m02n18.$iyrmid1."$ddd1".2hmm before the analysis day $TMmid1
echo $var_day2 files navysst.tmpobs.n19m02n18.$iyrmid2."$ddd2".0hmmafter the analysis day $TMmid2



if [ "$var_day" == "0" ]
then
echo YELLOW-WARNING: No satellite observation files on the analysis day $TMmid
#echo RED-STOP: No satellite observation files on the analysis day $TMmid
#exit
fi

if [ "$var_day" -lt "3" ]
then
echo YELLOW-WARNING: less than three satellite observation files on the analysis day $TMmid
fi


########### end of FTP get 6-hourly satellite data for today###########################

echo "************** end time for ftp satellite quality control code =" `date '+%T'`



file_in="/raid2/cliu/satellite/navy/"$iyrmid"/NAVYOBS.D"$ddd
echo $file_in

rm $file_in



ls -l /raid2/cliu/satellite/navy/"$iyrmid"/navysst.tmpobs.n19m02n18.$iyrmid."$ddd".*
ls -l /raid2/cliu/satellite/navy/"$iyrmid1"/navysst.tmpobs.n19m02n18.$iyrmid1."$ddd1".2*
ls -l /raid2/cliu/satellite/navy/"$iyrmid2"/navysst.tmpobs.n19m02n18.$iyrmid2."$ddd2".0*


cat /raid2/cliu/satellite/navy/"$iyrmid"/navysst.tmpobs.n19m02n18.$iyrmid."$ddd".* >> $file_in
cat /raid2/cliu/satellite/navy/"$iyrmid1"/navysst.tmpobs.n19m02n18.$iyrmid1."$ddd1".2* >> $file_in
cat /raid2/cliu/satellite/navy/"$iyrmid2"/navysst.tmpobs.n19m02n18.$iyrmid2."$ddd2".0* >> $file_in



#define the output file name for noaa19



#define the obs output for day satellite
file_dobs_out18="/raid2/sstday/$iyrmid/obs/navy/dsat18."$TMmid
echo $file_dobs_out18

#define the obs out put for night satellite
file_nobs_out18="/raid2/sstday/$iyrmid/obs/navy/nsat18."$TMmid
echo $file_nobs_out18

# define the good SST grid file
file_dgrid_out18='/raid2/sstday/'$iyrmid'/grads/navy/daynavy18.sst.'$TMmid
echo $file_dgrid_out18
file_ngrid_out18='/raid2/sstday/'$iyrmid'/grads/navy/ntenavy18.sst.'$TMmid
echo $file_ngrid_out18


# define the sobs
file_dsobs_out18='/raid2/sstday/'$iyrmid'/sobs/navy/dsat18/dsat18.'$TMmid
echo $file_dsobs_out18
file_nsobs_out18='/raid2/sstday/'$iyrmid'/sobs/navy/nsat18/nsat18.'$TMmid
echo $file_nsobs_out18

cov_sat=2.5
cov_sat2=0.0

cov_name_sat="/raid2/cliu/sstday/script/cover_sat.txt"
echo $cov_name_sat

isource=8
cat <<oiEOF > satellite.parm
$quarter_mask_in
$file_stdev_in
$file_in
$navyeotfg
$file_dobs_out18
$file_nobs_out18
$file_dgrid_out18
$file_ngrid_out18
$file_dsobs_out18
$file_nsobs_out18
$cov_name_sat
$iyrmid $immid $idmid 
$isource
$cov_sat
$cov_sat2
oiEOF

  ./satellite_navy_daily_firstguessclim_6hr_col.x -Wl,-T <satellite.parm 
stopcode=$?  
echo 'satellite_navy_daily_firstguessclim_6hr_col.x : call exit ' $stopcode

coverage=`cat /raid2/cliu/sstday/script/cover_sat.txt`
echo $coverage

export noaa19_day_cov=${coverage:0:4}
echo $noaa19_day_cov
export noaa19_nte_cov=${coverage:5:4}
echo $noaa19_nte_cov


if [ $stopcode -eq 1 ]
then
echo 'GREEN-SUCCESSFUL! satellite_navy18 MAIN'
fi

if [ $stopcode -eq 10 ]
then
#    echo 'YELLOW-WARNING! ERROR satellite_navy_daily_firstguessclim_6hr_col.x' $stopcode
echo 'ERROR satellite_navy_daily_firstguessclim_6hr_col.x' $stopcode
fi

if [ $stopcode -eq 100 ]
then
#echo 'RED-STOP! satellite'
  exit
fi

if [ $stopcode -ne 1 -a $stopcode -ne 10 -a $stopcode -ne 100 ]
then
  echo 'RED-STOP: satellite_navy_daily_firstguessclim_6hr_col.f navy18 data error'
  exit
fi

#define the output file name for metop

#define the obs output for day satellite
file_dobs_out17="/raid2/sstday/$iyrmid/obs/navy/dsat17."$TMmid
echo $file_dobs_out17

#define the obs out put for night satellite
file_nobs_out17="/raid2/sstday/$iyrmid/obs/navy/nsat17."$TMmid
echo $file_nobs_out17

# define the good SST grid file
file_dgrid_out17='/raid2/sstday/'$iyrmid'/grads/navy/daynavy17.sst.'$TMmid
echo $file_dgrid_out17
file_ngrid_out17='/raid2/sstday/'$iyrmid'/grads/navy/ntenavy17.sst.'$TMmid
echo $file_ngrid_out17


# define the sobs
file_dsobs_out17='/raid2/sstday/'$iyrmid'/sobs/navy/dsat17/dsat17.'$TMmid
echo $file_dsobs_out17
file_nsobs_out17='/raid2/sstday/'$iyrmid'/sobs/navy/nsat17/nsat17.'$TMmid
echo $file_nsobs_out17


isource=12
echo $isource

cat <<oiEOF > satellite.parm
$quarter_mask_in
$file_stdev_in
$file_in
$navyeotfg
$file_dobs_out17
$file_nobs_out17
$file_dgrid_out17
$file_ngrid_out17
$file_dsobs_out17
$file_nsobs_out17
$cov_name_sat
$iyrmid $immid $idmid 
$isource
$cov_sat
$cov_sat2
oiEOF
  
  ./satellite_navy_daily_firstguessclim_6hr_col.x -Wl,-T <satellite.parm
  stopcode=$?  
echo 'satellite_navy_daily_firstguessclim_6hr_col.x : call exit ' $stopcode

coverage=`cat /raid2/cliu/sstday/script/cover_sat.txt`
echo $coverage

export metop_day_cov=${coverage:0:4}
echo $metop_day_cov
export metop_nte_cov=${coverage:5:4}
echo $metop_nte_cov


if [ $stopcode -eq 1 ]
then
echo 'GREEN-SUCCESSFUL! satellite_navy17 MAIN'
fi

if [ $stopcode -eq 10 ]
then
#    echo 'YELLOW-WARNING! ERROR satellite_navy_daily_firstguessclim_6hr_col.x' $stopcode
echo 'warning satellite_navy_daily_firstguessclim_6hr_col.x' $stopcode
#    ./satellite_navy_daily_firstguessclim_6hr_col.x -Wl,-T <satellite.parm > /raid2/cliu/sstday/script/output/satellite_navy17_firstguessclim_6hr.out.$TMmid
#    cat /raid2/cliu/sstday/script/output/satellite_navy17_firstguessclim_6hr.out.$TMmid
fi

if [ $stopcode -eq 100 ]
then
#echo 'RED-STOP! satellite'
#    ./satellite_navy_daily_firstguessclim_6hr_col.x -Wl,-T <satellite.parm > /raid2/cliu/sstday/script/output/satellite_navy17_firstguessclim_6hr.out.$TMmid
#    cat /raid2/cliu/sstday/script/output/satellite_navy17_firstguessclim_6hr.out.$TMmid
  exit
fi

if [ $stopcode -ne 1 -a $stopcode -ne 10 -a $stopcode -ne 100 ]
then
  echo 'RED-STOP: satellite_navy_daily_firstguessclim_6hr_col.f navy17 data error'
  exit
fi

# rm $file_in


# delete the daily navy obs temperory file ihr,lat,lon,isst in ascii.
rm $file_dobs_out18
rm $file_nobs_out18
rm $file_dobs_out17
rm $file_nobs_out17

echo "************** end time for run satellite quality control code =" `date '+%T'`


echo '################# ftp sea ice obs ####################'

echo "************** start time to get sea ice data =" `date '+%T'`

# using the wgrib ice ascii format to read the ice


# get analysis day's half degree ice by wgrib

rm ftpice
echo user anonymous chunying.liu@noaa.gov >> ftpice
echo cd pub >> ftpice
echo cd cdas >> ftpice
echo ls eng.$TMmid >> ftpice
echo binary >> ftpice
echo get eng.$TMmid >> ftpice
echo cd archive >> ftpice
echo get ice.$iyrmid$immid.gz >> ftpice
echo quit >> ftpice

  ftp -n -v -i polar.ncep.noaa.gov < ftpice
  
echo "************** end time for ftp ice data =" `date '+%T'`
  

  if [ -f  eng.$TMmid ]
  then 
  echo eng.$TMmid exist
  
    # get the grib info file to check the header
  mv  eng.$TMmid  /raid2/sstday/ice/$iyrmid/
  chgrp oisst /raid2/sstday/ice/$iyrmid/eng.$TMmid
  
  # first check if the date in the hearder is the processing day's date
  TMtoday=`/usr/local/bin/wgrib /raid2/sstday/ice/$iyrmid/eng.$TMmid -4yr -d 1 | gawk '{print substr($0,index($0,"d=")+2,8)}' -`


  if [ "$TMtoday" != "$TMmid" ]
  then 
  echo 'YELLOW-WARNING: date in the header is not match today'
  echo 'analysis day TMmid=' $TMmid
  echo 'date in grib ice TMtoday=' $TMtoday
  echo 'continue running'
  fi
  
  rm /raid2/cliu/sstday/script/wgrib_info
  
 
  if [ "$TMtoday" != "" ]
  then
 /usr/local/bin/wgrib /raid2/sstday/ice/$iyrmid/eng.$TMmid -V -d 1 > /raid2/cliu/sstday/script/wgrib_info


# The scan direction changed. The ice data from S-N instead N-S since 1981/11/01 to 1991/12/02

var_lat=`grep "lat  89.750000 to -89.750000 by 0.500000  nxny 259200" /raid2/cliu/sstday/script/wgrib_info -c`
echo $var_lat
var_lon=`grep "long 0.250000" /raid2/cliu/sstday/script/wgrib_info -c`
echo $var_lon
var_scan=`grep "scan 0" /raid2/cliu/sstday/script/wgrib_info -c`
echo $var_scan


  if [ "$var_lon" -le "0" ]
  then
  echo 'Wrong starting lon or size !!!'
  fi

  if [ "$var_lat" -le "0" ]
  then
  echo 'Wrong starting lat or size !!!'
  fi

  if [ "$var_scan" -le "0" ]
  then
  echo 'Wrong scan direction !!!'
  fi

  if [ "$var_lat" -ge "1" -a "$var_lon" -ge "1" -a "$var_scan" -ge "1" ]
  then 

  # define the output ice name after wgrib   
  ice_globe="/raid2/sstday/ice/$iyrmid/ice."$TMtoday
  echo $ice_globe
  
  /usr/local/bin/wgrib /raid2/sstday/ice/$iyrmid/eng.$TMmid -d 1 -text -o $ice_globe

  # define the input name to convert it to 1/4 degree in Fortran  
  file_in=$ice_globe
  echo $file_in
  
  
  
  # using the wgrib ice ascii format to read the ice
iwget=0
echo 'iwget='$iwget


iyrmid00=`expr $TMtoday | cut -c1-4`
immid00=`expr $TMtoday | cut -c5-6`
idmid00=`expr $TMtoday | cut -c7-8`

echo $iyrmid00
echo $immid00
echo $idmid00 


file_out_720x360="/raid2/sstday/$iyrmid00/grads/ice/icecon720x360."$TMtoday
echo $file_out_720x360

file_out_1440x720="/raid2/sstday/$iyrmid00/grads/ice/icecon."$TMtoday
echo $file_out_1440x720

cat << oiEOF > ice_read.parm
$quarter_mask_in
$file_in
$file_out_720x360
$file_out_1440x720
$iyrmid00 $immid00 $idmid00
$iwget
oiEOF

  ./ice2_1440x720_col.x -Wl,-T <ice_read.parm
stopcode=$?  
echo 'ice2_1440x720_col.x: call exit ' $stopcode

if [ $stopcode -eq 10 ]
then
    echo 'yellow-warning: ice2_1440x720_col.x:' $stopcode
#    ./ice2_1440x720.x -Wl,-T <ice_read.parm > /raid2/cliu/sstday/script/output/ice2_1440x720.out.$TMtoday
#    cat /raid2/cliu/sstday/script/output/ice2_1440x720.out.$TMtoday
    
fi  

if [ $stopcode -eq 100 ]
then
#  echo 'RED-STOP! ice2_1440x720_col.x'
#    ./ice2_1440x720.x -Wl,-T <ice_read.parm > /raid2/cliu/sstday/script/output/ice2_1440x720.out.$TMtoday
#    cat /raid2/cliu/sstday/script/output/ice2_1440x720.out.$TMtoday
  exit
fi

if [ $stopcode -ne 1 -a $stopcode -ne 10 -a $stopcode -ne 100 ]
then
  echo 'RED-STOP: ice2_1440x720_col.f data error'
  exit
fi

rm $file_out_720x360
  
  
  
  else
  TMtoday=""
  echo 'YELLOW-WARNING: erro found in ice data eng.'$TMmid  
  fi 
  
  fi 



else
echo 'YELLOW-WARNING: Can not get ice data on analysis day, but keep running' $TMmid
fi 



# need cat the 7 daily 1/4 degree file to one big input file 
# define the one big ice concentration file name
ice_in="/raid2/sstday/$iyrmid/grads/ice/icecon7."$TMmid

if [ -f  $ice_in ]
  then 
  rm $ice_in
fi  

  nnn=1
  interval=-6
  kdays=0   
while [ "$nnn" -le "7" ]

do
echo $nnn
echo $interval

if [ "$interval" -lt "0" ]
then
TM0=`sh /raid/cliu/oiweekly/script/finddate.sh $TMmid d$interval`
echo $TM0

elif [ "$interval" -eq "0" ]
then
TM0=$TMmid
echo $TM0

else
TM0=`sh /raid/cliu/oiweekly/script/finddate.sh $TMmid d+$interval`
echo $TM0
fi

year=`echo $TM0 | cut -c1-4`
month=`echo $TM0 | cut -c5-6`
day=`expr $TM0 | cut -c7-8`


ice_con="/raid2/sstday/$year/grads/ice/icecon."$TM0

if [ -f  $ice_con ]
then 
kdays=`expr $kdays + 1` 
cat $ice_con >> $ice_in
ls -l $ice_con
ls -l $ice_in
else
echo $ice_con ' not exist'
fi
echo 'kdays:' $kdays

#echo "Pausing....."
#read  why
  
nnn=`expr $nnn + 1`
interval=`expr $interval + 1`

done


if [ $kdays != 0 ]
then 

#calculate ice sst  
  
  if [ -f  $ice_in ]
  then 
  echo $ice_in ' exist'

# define the output medium ice concentration

icecon_med="/raid2/sstday/$iyrmid/grads/ice-med/icecon."$TMmid
echo $icecon_med 


# define the output ice sst file for GrADS

ice_grads_out="/raid2/sstday/$iyrmid/grads/ncep/icesst/fit1sst."$TMmid
echo $ice_grads_out  

# define the output ice sst file for OI

ice_sobs_out="/raid2/sstday/$iyrmid/sobs/ncep/icesst/icesst."$TMmid
echo $ice_sobs_out  

cov_ice=6.0
cov_ice2=0.0
cov_name_ice="/raid2/cliu/sstday/script/cover_ice.txt"
echo $cov_name_ice

cat << sstEOF > ice2sst.parm
$ice_in
$icecon_med
$ice_grads_out
$ice_sobs_out
$cov_name_ice
$iyrmid $immid $idmid $kdays
$cov_ice
$cov_ice2
sstEOF

echo 'run ncep_ice2sst_med_col.x  '
  ./ncep_ice2sst_med_col.x -Wl,-T <ice2sst.parm 
  
  stopcode=$?  
echo 'ncep_ice2sst_med_col.x : call exit ' $stopcode

coverage=`cat /raid2/cliu/sstday/script/cover_ice.txt`
echo $coverage

export ice_cov=${coverage:0:4}
echo $ice_cov

if [ $stopcode -eq 10 ]
then
echo 'warnibg ncep_ice2sst_med_col.x' $stopcode
#    echo 'YELLOW-WARNING! ncep_ice2sst_med_col.x' $stopcode
#    ./ncep_ice2sst_med.x -Wl,-T <ice2sst.parm > /raid2/cliu/sstday/script/output/ncep_ice2sst_med_out.$TMmid
#    cat /raid2/cliu/sstday/script/output/ncep_ice2sst_med_out.$TMmid
fi  

if [ $stopcode -eq 100 ]
then
#    echo 'RED-STOP! ncep_ice2sst_med_col.x'
#    ./ncep_ice2sst_med.x -Wl,-T <ice2sst.parm > /raid2/cliu/sstday/script/output/ncep_ice2sst_med_out.$TMmid
#    cat /raid2/cliu/sstday/script/output/ncep_ice2sst_med_out.$TMmid
  exit
fi

if [ $stopcode -ne 1 -a $stopcode -ne 10 -a $stopcode -ne 100 ]
then
  echo 'RED-STOP: ncep_ice2sst_med_col.f data error'
  exit
fi

rm $ice_grads_out        
else
echo $ice_in ' not exist! ice sobs can not be calculated'
echo 'Warning!!! generate empty ice sobs'
#exit
fi

else

echo ' can not find ice for 7 days, calculate empty sobs'


# define the empty ice file name  
  
  
  empty_sst="/raid2/sstday/$iyrmid/sobs/ncep/icesst/icesst."$TMmid
  echo $empty_sst
  
  empty_sst_grid="/raid2/sstday/$iyrmid/grads/ncep/icesst/fit1sst."$TMmid
  echo $empty_sst_grid 
 

cat << oiEOF > empty.parm
$empty_sst
$empty_sst_grid
$iyrmid $immid $idmid
oiEOF

     
 ./empty_ice1440x720.x -Wl,-T <empty.parm > emptyout
   stopcode=$?  
echo 'empty_ice1440x720.x : call exit ' $stopcode

export ice_cov=0
echo $ice_cov

if [ $stopcode -eq 10 ]
then

    echo 'WARNING-YELLOW! ERROR empty_ice1440x720.x' $stopcode
fi 

if [ $stopcode -eq 100 ]
then
echo 'RED-STOP: empty_ice1440x720.f'
  exit
fi 

if [ $stopcode -ne 1 -a $stopcode -ne 10 -a $stopcode -ne 100 ]
then
  echo 'RED-STOP: empty_ice1440x720.f data error'
  exit
fi

rm $empty_sst_grid

fi


echo "************** end time for run ice quality control code =" `date '+%T'`

rm $ice_in 



echo '############### end of geting and QC buoy ship, satellite, ice obs ##################'


# write out the successful run date file


echo $TMmid > /raid2/cliu/sstday/script/oi_intv2_date.txt

#cat <<inxEOF> /raid2/cliu/sstday/script/oi_intv2_date.txt
#$TMmid
#inxEOF

echo '############### start NAVY19 METOP OI intv2 analysis run #################'

/raid2/cliu/sstday/script/oisst_avhrr_only_intv2.sh 

echo '############### end NAVY19 METOP OI intv2 analysis run ####################'
#find the next day.
  
  TMg=$TMmid
  TMmid=`sh /raid2/cliu/sstday/script/finddate.sh $TMg d+1`
  
  iyrmid=`expr $TMmid | cut -c1-4`
  immid=`expr $TMmid | cut -c5-6`
  idmid=`expr $TMmid | cut -c7-8`

echo $iyrmid
echo $immid
echo $idmid
 
done
