c        1         2         3         4         5         6         7
c23456789012345678901234567890123456789012345678901234567890123456789012
c     7                                                               72
c     |                                                                |
c     program ncep_ice2sst_med_col.f
c     modified from ncep_ice2sst.f
c     1. consider the special regions  idrop
c     2. read in 7 days 0.25 degree ice, 
c        using the medium ice concentration of the 7 days to generate sst
c     Oct. 2006
c
      PARAMETER (JREC=10000,imx=1440,imy=720,nday=7) 
      dimension aa4(imx,3,12),bb4(imx,3,12),cc4(imx,3,12)
      dimension bl4(imx,3,12),cl4(imx,3,12)
      dimension aa4i(imx,3),bb4i(imx,3),cc4i(imx,3)
      dimension bl4i(imx,3),cl4i(imx,3)
      dimension xt(imx),yt(imy),ccos(imy),vmed(nday)
      dimension cidat(imx,imy),cidatx(imx,imy,nday)
      dimension sst1(imx,imy),sst2(imx,imy)
      dimension cmask(imx,imy),idrop(12,36),bmask(imx,imy)
      integer sea_ict
c
c  rms1, bias1 for linear
c  rms2, bias2 for 2nd order
c
c
c     concentrations ranges are 0.1 - 0.9 with values -0.5 and + 0.5
c     ic = 10*(cidat+0.05) use if ice ranges between 1 and 9

      character*80 ice_in,icecon_med,ice_sobs_out,ice_grads_out
      CHARACTER*8 TYPE
      dimension wsst(jrec),wlat(jrec),wlon(jrec),wnum(jrec)
      logical lexist
      
      external compar
      integer*2 compar

        call timer (itime1)     

        read 666, ice_in,icecon_med,ice_grads_out,ice_sobs_out
        read *,   iyrmid, immid, idmid,kdays
	read *, cov_ice
        read *, cov_ice2
	 
666     format(a80)  
        
        print*, 'Input  1/4 degree ice concentration:', ice_in
        print*, 'Output 1/4 degree ice sst grads file:',ice_grads_out
	print*, 'Output 1/4 degree ice sst sobs:    ', ice_sobs_out
	print*, 'Day of process:                 ', iyrmid, immid, idmid
	print*, 'number of days have ice:        ', kdays
	print*, 'ice coverage:                   ', cov_ice,cov_ice2
c
      open (30,file='/raid2/sstday/clim/ice_flags_mask.dat',
     1 form='unformatted')
      open (40,file='/raid2/sstday/clim/land/quarter-mask-extend',
     1 form='unformatted')
      open (20,file='/raid2/sstday/clim/gsfc-fit-coef-fill-final',
     1 form='unformatted')
      data type /'ncep_ice'/
c
      iz = 71
      
      do i=1,12
        read (20) ((aa4(j,k,i),j=1,imx),k=1,3)
        read (20) ((bb4(j,k,i),j=1,imx),k=1,3)
        read (20) ((cc4(j,k,i),j=1,imx),k=1,3)
        read (20) ((bl4(j,k,i),j=1,imx),k=1,3)
        read (20) ((cl4(j,k,i),j=1,imx),k=1,3)
      enddo
      undef = -9999.
c

     
      call minmx3 (aa4,imx,3,12,undef,'aa-1/4  ')
      call minmx3 (bb4,imx,3,12,undef,'bb-1/4  ')
      call minmx3 (cc4,imx,3,12,undef,'cc-1/4  ')
      call minmx3 (bl4,imx,3,12,undef,'bl-1/4  ')
      call minmx3 (cl4,imx,3,12,undef,'cl-1/4  ')
      rad = 3.14159/180.
c
      read (30) cmask
      call maxmin (cmask,imx,imy,undef,'land sea  ')
      call maxmin (cmask,imx,imy,0.,'ocean pts ')
      
      read (40) bmask
c      call maxmin (bmask,1440,720,1.,'land pts  ')
c      call maxmin (bmask,1440,720,0.,'ocean pts ')
      
c     count how may sea pixels to calculate ice data coverage.      
      sea_ict=0
      do i=1,imx
      do j=1,imy
      if(bmask(i,j).eq.1.0)then
      sea_ict=sea_ict+bmask(i,j)
      endif
      enddo
      enddo
      
      print*,'sea_ict=',sea_ict
c
c  The Great Lakes (special row 2) is set to 22
c
c   lowest ice concentration to use is bin 0.5 with range: 0.45 - 0.55
c    thus set cmin to 0.45
c
c   Use First Order fit for all!
c
      cmin = 0.45
      print 106,cmin
  106 format ('cmin =',f8.3,'  no SST computed for ice below cmin')
      dall = 0.25
c      dall2 = 0.5*dall
      ay1 = -89.875
      ax1 = 0.125
      do i=1,imx
        xt(i) = dall*float(i-1) + ax1
      enddo
      call maxmin (xt,imx,1,undef,'alon    ')
      do j=1,imy
        yt(j) = dall*float(j-1) + ay1
	ccos(j) = cos(rad*yt(j))
      enddo
      call maxmin (yt,imy,1,undef,'alat    ')
      call maxmin (ccos,imy,1,undef,'cosine    ')

      
      iyr=iyrmid
      imo=immid
      ida=idmid         
c
c     first interpolate the coefficients to the correct day
c
      call idaycl (aa4,bb4,cc4,bl4,cl4,imo,ida,
     1 aa4i,bb4i,cc4i,bl4i,cl4i,ierr,imx)
c
      if (ierr.ne.0) then
        print *,'RED-STOP! SUBROUTINE-idaycl'
	call exit(100)
      endif
c
      do i=1,imx
        do j=1,imy
	  cidat(i,j) = undef
	enddo
      enddo
      
      
      open (iz,file=ice_sobs_out,form='unformatted')
      
      INQUIRE(FILE=ice_in,EXIST=LEXIST)
c          print *,lexist
      if(.not.lexist) then
	print *,'no data:',ice_in
        write (iz) iyr,imo,ida,type
        close (iz)
        go to 110
      endif  
      open (61,file=ice_grads_out,form='unformatted')
      open (31,file=ice_in,status='old',form='unformatted')
      
      do k=1,kdays
      
      READ (31,END=200) kyr,kmo,kda,cidat
      print 109,kyr,kmo,kda,kdays
109   format ('year =',i5,3x,'month =',i3,3x,'day =',i3,
     1  3x,'kdays =',i3)
        do i=1,imx
        do j=1,imy
	  if(cidat(i,j).lt.0)cidat(i,j) =0.
	  if(cmask(i,j).lt.0.5) then
	    cidatx(i,j,k) = undef
	    else
	    cidatx(i,j,k) = cidat(i,j)
	  endif
	enddo
	enddo
	
      enddo
      
c
c    compute median
c
c------------following part taken care by .sh------------
c      if (kdays.lt.1) then
c      	print *,'no data:',icecon_med
c        write (iz) iyr,imo,ida,type
c        close (iz)
c        go to 110
c      endif
c---------------------------------------------------------      
      
      n2 = kdays/2
      m1 = n2 + 1
      m2 = kdays - n2
      do i=1,imx
        do j=1,imy
	  if (cmask(i,j).lt.0.5) then
	     cidat(i,j) = undef
	  else
	    do ll=1,kdays
              vmed(ll) = cidatx(i,j,ll)
	    enddo
	    call qsort(vmed,kdays,4,compar)
            cidat(i,j) = 0.5*( vmed(m1) + vmed(m2) )
c	    if (iprt.eq.1.and.vmed(1).gt.0.) then
c	      print 901,kdays,cidat(i,j),(vmed(lll),lll=1,kdays)
c  901         format (i3,f8.3,3x,7f8.3)
c  	      iprt = 0
c	    endif	    
	    if (cidat(i,j).le.0.01) cidat(i,j) = undef
          endif 
        enddo
      enddo

      open (81,file=icecon_med,form='unformatted')
      write (81) iyr,imo,ida,cidat
      call maxmin (cidat,imx,imy,undef,'cice dat')      

      do ir=1,36
        do imoo=1,12
          idrop(imoo,ir) = 1
        enddo
      enddo

c      
      ir=13
      do imoo=1,12
        idrop(imoo,ir) = 0
      enddo
      do ir=17,19
        do imoo=6,10
          idrop(imoo,ir) = 0
        enddo
      enddo
      ir=22
      do imoo=1,12
        idrop(imoo,ir) = 0
      enddo
      do imoo=1,12
        print 301,imoo,idrop(imoo,13),(idrop(imoo,ir),ir=17,19),
     1   idrop(imoo,22)
  301 format ('imoo =',i3,3x,'idrop: 13, 17-19, 22 =',i3,2x,3i3,2x,i3)    
      enddo
      print *,'ir = 22 for Great Lakes, ir = 13 for Baltic'	
      print *,'ir = 17-19 for North Pacific'	
      print 118,nday,kdays
  118 format ('nday =',i3,3x,'kdays =',i3)
c     
c    now compute SSTs from sea ice  
c      
      do i=1,imx
        do j=1,imy
	  xx = cidat(i,j)
	  ival = nint(cmask(i,j))
	  if (ival.gt.0) then
	    idp = idrop(imo,ival)
c	    if (idp.eq.0) print *,'imo =',imo,'ireg =',ival
	  else
	    idp = 0
	  endif
	  
	  if (xx.ge.cmin.and.idp.eq.1) then
	    val = cmask(i,j) + 11.05
	    ir = ifix(val/12.)
	    if (ir.lt.1.or.ir.gt.3) then  
	      print*,'RED-STOP! MAIN-ncep_ice2sst_med_col.f'
	      print *,ir,'  bad row: stop 1002'
	      call exit(100)
	    endif

c sst2 is noliner fit, put here only for test purpose
	    
	    sst2(i,j) = aa4i(i,ir)*xx**2 + bb4i(i,ir)*xx + cc4i(i,ir)
	    sst1(i,j) =                    bl4i(i,ir)*xx + cl4i(i,ir)
	    if (sst2(i,j).lt.-1.81) then
              print 107,ir,sst2(i,j),aa4i(i,ir),bb4i(i,ir),cc4i(i,ir)
  107         format ('2nd order: row =',i3,2x,
     1          'sst =',f8.2,2x,'aa =',f8.2,2x,'bb =',f8.2,
     2           2x 'cc =',f8.2 )
	     endif
	     
	     if (sst1(i,j).lt.-1.81) then
               print 108,ir,sst1(i,j),bl4i(i,ir),cl4i(i,ir)
  108           format ('liner:      row =',i3,2x,
     1          'sst =',f8.2,2x,'bl =',f8.2,2x,'cl =',f8.2)
	     endif
	  else
	    sst2(i,j) = undef
	    sst1(i,j) = undef
	  endif
	enddo
      enddo  
      if (ida.eq.1) then
        call  maxmin (cidat,imx,imy,undef,'cice dat')
        call  maxmin (sst1,imx,imy,undef,'sst-lin ')
        call  maxmin (sst2,imx,imy,undef,'sst-2nd ')
      endif   
      print*,'imoimom=',imo     
      write (61) iyr,imo,ida,sst1
      close (61)

c
c  write out super obs for sst1 with dates only for missing ice !!
c
      write (iz) iyr,imo,ida,type
      ict = 0
      isup = 0
      iwrt = 0
      do i=1,imx
        do j=1,imy
          if (sst1(i,j).gt.undef) then
            ict = ict + 1
	    isup = isup + 1	
            wnum(ict) = 1. 
            wsst(ict) =  sst1(i,j) 
	    wlat(ict) =  yt(j)
	    wlon(ict) =  xt(i)
	    if (ict.eq.jrec) then
	      icts = ict
	      iwrt = iwrt + 1
	      write (iz) ict
	      write (iz) (wnum(k),k=1,ict)
	      write (iz) (wsst(k),k=1,ict)
	      write (iz) (wlat(k),k=1,ict)
	      write (iz) (wlon(k),k=1,ict)
	      ict = 0
	    endif
          endif
        enddo
      enddo
      if (ict.gt.0) then
	iwrt = iwrt + 1
	icts = ict
	write (iz) ict
	write (iz) (wnum(k),k=1,ict)
	write (iz) (wsst(k),k=1,ict)
	write (iz) (wlat(k),k=1,ict)
	write (iz) (wlon(k),k=1,ict)
	ict = 0
      endif
      print 111,isup,icts,iwrt
  111 format (3x,'number sup obs =',i10,3x,'last ict =',i8,
     1  3x,'num writes =',i3)
      close (iz)
  110 continue
  
c     caculate ice sobs coverage 
       cover=100.0*float(isup)/sea_ict
       
       print*,'ice sobs coverage=',cover
       if(cover.lt.cov_ice2)then 
       print 888,cover
888    format ('RED-STOP! ICE2SST-MAIN-necp_ice2sst_med_col.f',3x,
     1  ' sobs coverage too low, cover=',f5.2)
c        print*, 'RED-STOP! ICE2SST-MAIN-necp_ice2sst_med_col.f',
c     1 '  Ice sobs coverage too low, cover=',cover
      call exit (100) 
      endif 
      
      if(cover. ge. cov_ice2 .and. cover.lt.cov_ice)then
      print 999,cover
999    format ('YELLOW-WARNING! ICE2SST-MAIN-necp_ice2sst_med_col.f',3x,
     1  ' sobs coverage too low, cover=',f5.2) 
c      print*, 'YELLOW-WARNING! ICE2SST-MAIN-necp_ice2sst_med_col.f',
c     1 'Ice sobs coverage too low, cover=',cover
      call exit (10) 
      endif
  
      call timer (itime2)
      tsec = float(itime2-itime1)*.01
      print *,tsec,' seconds for complete ncep_ice2sst_med_col.f code'
      
      print*,'GREEN-SUCCESSFUL! MAIN-necp_ice2sst_med_col.f' 
      call exit(1)
  200 PRINT 302
  302 FORMAT ('YELLOW-WARNING! MAIN-necp_ice2sst_med_col.f: 
     1         PREMATURE END OF INPUT DATA')
      call exit (10)
      end
      
      subroutine maxmin (fld,im,jm,undef,name)
c
c   compute maximum, minium and average of fld and print
c
      dimension fld(im,jm)
      character*8 name
      real*8 ave,r
      fldmin = 1.e30
      fldmax = -fldmin
      inum = 0
      ave = 0.
      do 90 i=1,im
      do 90 j=1,jm
      if (fld(i,j).gt.undef) then
        inum = inum + 1
        ave = ave + fld(i,j)
        if (fldmin.gt.fld(i,j))  fldmin = fld(i,j)
        if (fldmax.lt.fld(i,j))  fldmax = fld(i,j) 
      endif
   90 continue
      if (inum.gt.0) then
        r = 1./float(inum)
        ave = ave*r
      else
        fldmin = 0.
        fldmax = 0.
      endif
      print 88,ave,fldmin,fldmax,inum,name
   88 format (' ave =',f10.3,2x,'min =',f10.3,2x,
     1 'max =',f10.3,2x,'inum =',i8,2x,a8)
      return 
      end
      
      subroutine minmx3 (fld,im,jm,km,undef,name)
c
c   compute maximum, minium and average of fld and print
c
      dimension fld(im,jm,km)
      character*8 name
      real*8 ave,r
      fldmin = 1.e30
      fldmax = -fldmin
      inum = 0
      ave = 0.
      do 90 i=1,im
      do 90 j=1,jm
      do 90 k=1,km
      if (fld(i,j,k).gt.undef) then
        inum = inum + 1
        ave = ave + fld(i,j,k)
        if (fldmin.gt.fld(i,j,k))  fldmin = fld(i,j,k)
        if (fldmax.lt.fld(i,j,k))  fldmax = fld(i,j,k) 
      endif
   90 continue
      if (inum.gt.0) then
        r = 1./float(inum)
        ave = ave*r
      else
        fldmin = 0.
        fldmax = 0.
      endif
      print 88,ave,fldmin,fldmax,inum,name
   88 format (' ave =',f10.3,2x,'min =',f10.3,2x,
     1 'max =',f10.3,2x,'inum =',i8,2x,a8)
      return 
      end
      subroutine idaycl (aa4,bb4,cc4,bl4,cl4,imo,ida,
     1 aa4i,bb4i,cc4i,bl4i,cl4i,ierr,imx)
      dimension aa4(imx,3,12),bb4(imx,3,12),cc4(imx,3,12)
      dimension bl4(imx,3,12),cl4(imx,3,12)
      dimension aa4i(imx,3),bb4i(imx,3),cc4i(imx,3)
      dimension bl4i(imx,3),cl4i(imx,3)
c$$$  subprogram documentation block                                    
c                .      .    .                                       .  
c subprogram:    dayclm1d      finds climatology of given day and month   
c   prgmmr: d. c. stokes     org: w/np24     date: 1996-8-9             
c                                                                       
c abstract: temporally interpolates the climatology field of the day    
c                                                                       
c$$$                                                                    
      dimension ndays(12)
c
      data ndays/31,28,31,30,31,30,31,31,30,31,30,31/
c  change february 29 to february 28: effect of leap year ignored       
      ierr = 0
      kmo = imo
      if (ndays(kmo).lt.ida) then
        kda = ndays(kmo)
      else
        kda = ida
      endif
c                                                                       
c  check for bad date                                                   
      if (kmo.lt.1.or.kmo.gt.12.or.kda.lt.1.or.kda.gt.ndays(kmo)) then
      print 10,kmo,kda
   10 format('interpolated climate for month = ',i3,3x,'day =',i3)
      print 222
  222 format (' WARNING-YELLOW interpolation error in dclim')
      ierr = 1
      return
      endif
      halfm1 = real(ndays(kmo))/2.
      if (kda.le.int(halfm1)) then
        if (kmo.eq.1) then
          jmo = 12
        else
          jmo = kmo-1
        endif
        d = halfm1 - real(kda) + .5
      else
        if (kmo.eq.12) then
          jmo = 1
        else
          jmo = kmo+1
        endif
        d = real(kda) - halfm1 - .5
      endif
      halfm2 = real(ndays(jmo))/2.
      span = halfm1+halfm2
      do j=1,3
        do i=1,imx
          t1 = aa4(i,j,kmo)
          t2 = aa4(i,j,jmo)
          aa4i(i,j) = ((t2-t1)/span)*d + t1
          t1 = bb4(i,j,kmo)
          t2 = bb4(i,j,jmo)
          bb4i(i,j) = ((t2-t1)/span)*d + t1
          t1 = cc4(i,j,kmo)
          t2 = cc4(i,j,jmo)
          cc4i(i,j) = ((t2-t1)/span)*d + t1
          t1 = bl4(i,j,kmo)
          t2 = bl4(i,j,jmo)
          bl4i(i,j) = ((t2-t1)/span)*d + t1
          t1 = cl4(i,j,kmo)
          t2 = cl4(i,j,jmo)
          cl4i(i,j) = ((t2-t1)/span)*d + t1
        enddo
      enddo
      return
      end
c      include '/home/cliu/lib/w3date.f'

      integer*2 function compar(arg1,arg2)
      real*4 arg1,arg2
      if(arg1.lt.arg2) then
        compar=-1
      else if(arg1.eq.arg2) then
        compar=0
      else
        compar=1
      endif
      return
      end
