c      usuing Chunying's OI run from 2007/1/1 to present

      subroutine put_cdf_navy_intv2_GHRSST(fname,sst2d,err2d,ice2d,
     1mask2d,cnetdate,sdate,ssdate,refdate,isecond,title)
c-----------------------------------------------------------------------
c     write out daily SSTs in netcdf format 
c  
      !include 'netcdf.inc' 
       use netcdf
       use typesizes
	
c*************** Dimention and variable declarations:
      character fname*96, sdate*10,sdate2*14, ssdate*10,ssdate2*14
      character timeunit*33,refdate*99,cnetdate*10
      character title*80

      integer ncid, iret
      integer*2 fillval,min,max 
c      byte fillval2
      integer*1 fillval2,min2,max2 
      real offset, scale
      integer*1 mask_flag1,mask_flag2,mask_flag3,mask_flag4        

c     Define variable ids as integers (output from nf_def_var later)
      integer  sstID
      integer  latID
      integer  lonID
c      integer  zlevID
      integer  timeID
      
      integer  errID
      integer  iceID
      integer  maskID

C     Define variable dimension IDs (output from nf_def_dim later)
      integer  latDimID
      integer  lonDimID
c      integer  zlevDimID
      integer  timeDimID

C     Define dimension type & lengths - specify here
      integer  lat_len
      integer  lon_len
c      integer  zlev_len
      integer  time_len 	!time records in the whole dataset/time series
      integer  time_nr		!actual time record in this dataset)
      parameter (lat_len = 720)
      parameter (lon_len = 1440)
      parameter (zlev_len = 1)
c      parameter (time_len = NF90_UNLIMITED) 
      parameter (time_len = 1)     
      parameter (time_nr = 1)
      parameter (fillval=-32768)
c      parameter (fillval2=int(-128,kind=1))
      parameter (fillval2=-128)
      
C     Define variables shapes
      real lat(lat_len)
      real lon(lon_len)
c      real zlev(zlev_len)
      integer  time(time_nr)
      integer  sstDimIDs(3)
      integer  errDimIDs(3)
      integer  iceDimIDs(3)
      integer  maskDimIDs(3)
 
      integer*2 sst(lon_len,lat_len,time_len)
      integer*2 err(lon_len,lat_len,time_len)
      integer*1 ice(lon_len,lat_len,time_len)
      integer*1 mask(lon_len,lat_len,time_len) 
      
      integer*2 sst2d(lon_len,lat_len)
      integer*2 err2d(lon_len,lat_len)
      integer*1 ice2d(lon_len,lat_len)
      integer*1 mask2d(lon_len,lat_len)
      
      data zlev/0./
      time = isecond
      
      sst(:,:,1)=sst2d(:,:)
      err(:,:,1)=err2d(:,:)
      ice(:,:,1)=ice2d(:,:)
      mask(:,:,1)=mask2d(:,:)
      
c********** print out for checking:	
c        print*,' checking in put_cdf ...'
        
c	print*,'time= ', time
	do j=300,300
	write(*,101)(sst(i,j,1),i=720,725)
	write(*,101)(err(i,j,1),i=720,725)
	write(*,101)(ice(i,j,1),i=720,725)
	write(*,101)(mask(i,j,1),i=720,725)
	enddo
101	format(1x,6i10)	

        sdate2=sdate//' UTC'
        print*,'sdate2:',sdate2
        ssdate2=ssdate//' UTC'
        print*,'ssdate2:',ssdate2	

c*****************open the nc file ID: ***************************
      print*,'output file = ',fname
      call check_err90( NF90_CREATE(fname,NF90_CLOBBER,ncid) )

c********************* write out the global attributes: ************

      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'Conventions',
     &     'CF-1.0')
      call check_err90(iret)

      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'title',title)
c     &      'Daily optimum interpolation(OI) SST on 1/4-degree grid, Int 
c     &rim V2;')  
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'DSD_entry_id',
     &     'NCDC-L4LRblend-GLOB-AVHRR_OI')
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'references',
     & 'Reynolds, et al.(2007) Daily High-resolution Blended Analyses. A 
     &vailable at ftp://eclipse.ncdc.noaa.gov/pub/OI-daily/daily-sst.pdf
     &')
      call check_err90(iret)
      
c      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'GDS_data_centre',
c     &     'NOAA NCDC')
c      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'institution',
     &     'NOAA/NESDIS/NCDC')
      call check_err90(iret) 
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'contact',
     & 'Richard.W.Reynolds@noaa.gov & Chunying.liu@noaa.gov')
      call check_err90(iret)          
       
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'GDS_version_id',
     &     'v1.0-rev1.7')
      call check_err90(iret) 
       
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'netcdf_version_id',
     &     '3.6.0-p1 of Jul  4 2005 16:41:16 $')
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'creation_date',
     &     cnetdate)
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'product_version',
     &     'Version 2.0')
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'history',
     &     'Version 2.0')
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'spatial_resolution',
     &'0.25 degree')
      call check_err90(iret)

      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'start_date',
     & sdate2)
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'start_time',
     & '00:00:00 UTC')
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'stop_date',
     & ssdate2)
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'stop_time',
     & '00:00:00 UTC')
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'westernmost_longitude',
     & -179.875)
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'easternmost_longitude',
     & 179.875)
      call check_err90(iret)            
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'southernmost_latitude',
     & -89.875)
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'northernmost_latitude',
     & 89.875)
      call check_err90(iret)
 
c      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'software_version',
c     &     'L4 Processor Version 1.2')
c      call check_err90(iret)

      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'file_quality_index',
     &     '0')
      call check_err90(iret)
           
      if(sdate .ge. '1985-01-04' .and. sdate .le.'1988-11-07')then
            
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'ESRL ICOADS, AVHRR9, GSFC ice')
      endif
      
      if(sdate .ge. '1988-11-08' .and. sdate .le.'1994-09-13')then
            
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'ESRL ICOADS, AVHRR11, GSFC ice')
      endif
      
      if(sdate .ge. '1994-09-14' .and. sdate .le.'1995-01-21')then
            
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'ESRL ICOADS, AVHRR9, GSFC ice')
      endif
       
      if(sdate .ge. '1995-01-22' .and. sdate .le.'2000-10-11')then
            
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'ESRL ICOADS, AVHRR14, GSFC ice')
      endif 
      
      if(sdate .ge. '2000-10-12' .and. sdate .le.'2002-12-31')then
            
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'ESRL ICOADS, AVHRR16, GSFC ice')
      endif
      
      if(sdate .ge. '2003-01-01' .and. sdate .le.'2004-12-31')then
            
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'ESRL ICOADS, AVHRR17, GSFC ice')
      endif
      
      if(sdate .ge. '2005-01-01' .and. sdate .le.'2005-12-31')then
            
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'ESRL ICOADS, AVHRR17, NCEP ice')
      endif
            
      if(sdate .ge. '2006-01-01' .and. sdate .le.'2006-12-31')then
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'NCEP GTS, AVHRR17, NCEP ice')
       endif
       
      if(sdate .ge. '2007-01-01'.and. sdate .le.'2008-12-31')then            
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'NCEP GTS, AVHRR17, AVHRR18, NCEP ice')
       endif
       
       if(sdate .ge. '2009-01-01' .and. sdate .le.'2011-08-15')then            
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'NCEP GTS, AVHRR18, METOIP, NCEP ice')
       endif
       
       if(sdate .ge. '2011-08-16' )then            
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'source_data',
     &'NCEP GTS, AVHRR19, METOIP, NCEP ice')
       endif


       iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'comment',
     &'WARNING Some applications are unable to properly handle signed by
     &te values. If values are encountered > 127, please subtract 256 fr
     &om this reported value')
      call check_err90(iret)
      
c********************* end of global attributes: ***************************
              
C     call out dimension IDs w/ error checks:
c      call check_err90( nf90_def_dim(ncid,'time',NF90_UNLIMITED,
c      &							timeDimID) )
      
                       
      call check_err90( nf90_def_dim(ncid,'lat',lat_len,latDimID) )
      call check_err90( nf90_def_dim(ncid,'lon',lon_len,lonDimID) )
      call check_err90( nf90_def_dim(ncid,'time',time_nr,timeDimID) )
      
c      call check_err90( nf90_def_dim(ncid,'zlev',zlev_len,zlevDimID))
      
     
C     call out variables IDs & assign attributes:
      !call put variable IDs:      
 					
      iret = nf90_def_var(ncid,'lat',NF90_REAL,latDimID,latID)
      					call check_err90(iret)
      iret = nf90_def_var(ncid,'lon',NF90_REAL,lonDimID,lonID)
      					call check_err90(iret)
					
      iret = nf90_def_var(ncid, 'time',NF90_INT,timeDimID,timeID)
      					call check_err90(iret)
      
c      iret = nf90_def_var(ncid,'zlev',NF90_REAL,zlevDimID,zlevID)
c      					call check_err90(iret)

                                        sstDimIDs(3) = timeDimID
      					sstDimIDs(2) = latDimID
      					sstDimIDs(1) = lonDimID					
      iret = nf90_def_var( ncid,'analysed_sst',NF90_SHORT,sstDimIDs,
     1 sstID)
					call check_err90(iret)
					
					errDimIDs(3) = timeDimID
					errDimIDs(2) = latDimID
      					errDimIDs(1) = lonDimID
      iret = nf90_def_var(ncid,'analysis_error',NF90_SHORT,errDimIDs,
     1 errID)
					call check_err90(iret)					
	 				
					maskDimIDs(3) = timeDimID
					maskDimIDs(2) = latDimID
      					maskDimIDs(1) = lonDimID
      iret = nf90_def_var(ncid,'mask',NF90_BYTE,maskDimIDs,maskID)
					call check_err90(iret)
					
					iceDimIDs(3) = timeDimID
					iceDimIDs(2) = latDimID
      					iceDimIDs(1) = lonDimID
      iret = nf90_def_var(ncid,'sea_ice_fraction',NF90_BYTE,iceDimIDs,
     1 iceID)
					call check_err90(iret)				
									
c******************************************************************      
      !Assign attributes:
      
      iret = nf90_put_att(ncid, timeID, 'long_name',
     &                    'reference time of sst field')
      print*,'sdate:',sdate

      iret = nf90_put_att(ncid, timeID, 'standard_name', 'time')
      iret = nf90_put_att(ncid, timeID, 'axis','T')
c      iret = nf90_put_att(ncid, timeID, 'calendar','Gregorian')
c      timeunit='hours since '//sdate//' 0 UTC'
      timeunit='seconds since '//refdate//' 00:00:00'
      iret = nf90_put_att(ncid, timeID, 'units',timeunit)
      					call check_err90(iret) 
					     					        

      iret = nf90_put_att(ncid, lonID, 'long_name','longitude')
                                        call check_err90(iret)
      iret = nf90_put_att(ncid, lonID, 'standard_name','longitude')
                                        call check_err90(iret)
      iret = nf90_put_att(ncid, lonID, 'axis','X')
                                        call check_err90(iret)
      iret = nf90_put_att(ncid, lonID, 'units', 'degrees_east')
     					call check_err90(iret)
      iret = nf90_put_att(ncid, lonID, 'comment', 
     &             'uniform grid from -179.875 to 179.875 by 0.25')
      					call check_err90(iret) 
					
	
      iret = nf90_put_att(ncid, latID, 'long_name','latitude') 
                                        call check_err90(iret)
      iret = nf90_put_att(ncid, latID, 'standard_name','latitude')
                                        call check_err90(iret)
      iret = nf90_put_att(ncid, latID, 'axis','Y')
                                        call check_err90(iret)
      iret = nf90_put_att(ncid, latID, 'units', 'degrees_north')
      					call check_err90(iret)    
      iret = nf90_put_att(ncid, latID, 'comment', 
     &             'uniform grid from -89.875 to 89.875 by 0.25')
      					call check_err90(iret)  				
					   

c      iret = nf90_put_att(ncid, zlevID, 'long_name', 
c     &                              'Sea surface height')
c     					call check_err90(iret)
c      iret = nf90_put_att(ncid, zlevID, 'units', 'meters')
c     					call check_err90(iret)
c      iret = nf90_put_att(ncid, zlevID, 'actual_range', '0, 0')
c     					call check_err90(iret)	

      offset=273.15
      scale=0.01
      min=-300
      max=4500			
     			
      iret = nf90_put_att(ncid, sstID, 'long_name', 
     &   'analysed sea surface temperature')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'standard_name', 
     &   'sea_surface_temperature')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'type', 'foundation')
      					call check_err90(iret)				
      iret = nf90_put_att(ncid, sstID, 'units', 'kelvin')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, '_FillValue', fillval)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'add_offset', offset)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'scale_factor', scale)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'valid_min', min)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'valid_max', max)
      					call check_err90(iret)
      offset=0.0
      scale=0.01
      min=0
      max=127				
										
      iret = nf90_put_att(ncid, errID, 'long_name', 
     &   'estimated error standard deviation of analysed_sst')      
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'units', 'kelvin')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, '_FillValue', fillval)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'add_offset', offset)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'scale_factor', scale)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'valid_min', min)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'valid_max', max)
      					call check_err90(iret)
					
      mask_flag1=1
      mask_flag2=2
      mask_flag3=4
      mask_flag4=8								
					
      iret = nf90_put_att(ncid, maskID, 'long_name', 
     &   'sea/land field composite mask')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, maskID, '_FillValue', fillval2)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, maskID, 'flag_values', 
     & mask_flag1)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, maskID, 'flag_meanings', 
     &                                  'sea land lake ice')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, maskID, 'comment', 
     &                   'b0:1=grid cell is open sea water'//
     & ' b1:1=land is present in this grid cell'//
     & ' b2:1=lake surface is present in this grid cell'//
     & ' b3:1=sea ice is present in this grid cell'//
     & ' b4-b7:reserve for future grid mask data')
      					call check_err90(iret)	
      offset=0.0
      scale=0.01
      min2=0
      max2=100
 					
      iret = nf90_put_att(ncid, iceID, 'long_name', 
     &   'sea ice area fraction')
      iret = nf90_put_att(ncid, iceID, 'standard_name', 
     &   'sea ice area fraction')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'units', 'percent')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, '_FillValue', fillval2)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'add_offset', offset)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'scale_factor', scale)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'valid_min', min2)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'valid_max', max2)
      					call check_err90(iret)															
		
   
C     leave define mode
      call check_err90( NF90_ENDDEF(ncid) )

C     store time:
c      time(1)=1
      call check_err90( nf90_put_var(ncid, timeID, time) )
    
C     store lon
      do ic=1,lon_len
          lon(ic)= -179.875+(ic-1)*0.25
      enddo
      call check_err90( nf90_put_var(ncid, lonID, lon) )
      
C     store lat:
      do ic=1,lat_len
          lat(ic)= -89.875+(ic-1)*0.25
      enddo
      call check_err90( nf90_put_var(ncid, latID, lat) )

C     store zlev
c      call check_err90( nf90_put_var(ncid, zlevID, zlev) )

C     store sst
      call check_err90( nf90_put_var(ncid, sstID, sst) )
      call check_err90( nf90_put_var(ncid, errID, err) )     
      call check_err90( nf90_put_var(ncid, maskID, mask) )
      call check_err90( nf90_put_var(ncid, iceID, ice) )
      
   
c*********************** close out the nc file:
      call check_err90( nf90_close(ncid) )	! close output file

      return
      end
