      subroutine put_cdf_navy_intv2_NOMADS(fname,sst2d,anom2d,err2d,
     2 ice2d,cnetdate,sdate,refdate,iday,title,buoyship_cov,sat_cov,
     3 iceice_cov)
c-----------------------------------------------------------------------

c     write out daily SSTs in netcdf format 
c  
      !include 'netcdf.inc' 
	use netcdf
      	use typesizes 
	
c*************** Dimention and variable declarations:
      character fname*70, sdate*10, timeunit*33,refdate*99,cnetdate*16
      character title*80,buoyship_cov*11,sat_cov*23,iceice_cov*5      
c
      integer ncid, iret
      integer*2 fillval,min,max
      real offset, scale

c     Define variable ids as integers (output from nf_def_var later)
      integer  sstID
      integer  latID
      integer  lonID
      integer  zlevID
      integer  timeID
      integer  errID
      integer  anomID
      integer  iceID

C     Define variable dimension IDs (output from nf_def_dim later)
      integer  latDimID
      integer  lonDimID
      integer  zlevDimID
      integer  timeDimID

C     Define dimension type & lengths - specify here
      integer  lat_len
      integer  lon_len
      integer  zlev_len
      integer  time_len 	!time records in the whole dataset/time series
      integer  time_nr		!actual time record in this dataset)
      parameter (lat_len = 720)
      parameter (lon_len = 1440)
      parameter (zlev_len = 1)
c      parameter (time_len = NF90_UNLIMITED) 
      parameter (time_len = 1)     
      parameter (time_nr = 1)
      parameter (fillval=-999)
      
C     Define variables shapes
      real lat(lat_len)
      real lon(lon_len)
      real zlev(zlev_len)
      integer  time(time_nr)
      integer  sstDimIDs(4)
      integer  errDimIDs(4)
      integer  anomDimIDs(4)
      integer  iceDimIDs(4)
      
      integer*2 sst(lon_len, lat_len,zlev_len,time_nr)
      integer*2 anom(lon_len, lat_len,zlev_len,time_nr)
      integer*2 err(lon_len, lat_len,zlev_len,time_nr)
      integer*2 ice(lon_len, lat_len,zlev_len,time_nr)
      
      integer*2 sst2d(lon_len, lat_len)
      integer*2 anom2d(lon_len, lat_len)
      integer*2 err2d(lon_len, lat_len)
      integer*2 ice2d(lon_len, lat_len)

      data zlev/0./
      time=iday
      
      sst(:,:,1,1)=sst2d(:,:)
      anom(:,:,1,1)=anom2d(:,:)
      err(:,:,1,1)=err2d(:,:)
      ice(:,:,1,1)=ice2d(:,:)
      
c********** print out for checking:	
c        print*,' checking in put_cdf ...'
c	print*,'time= ', time
        print*,'check if the value read right before put to NetCDF'
	do j=300,300
	write(*,101)(sst(i,j,1,1),i=720,725)
	write(*,101)(anom(i,j,1,1),i=720,725)	
	write(*,101)(ice(i,j,1,1),i=720,725)
	write(*,101)(err(i,j,1,1),i=720,725)
	enddo
101	format(1x,6i10)	

c*****************open the nc file ID: ***************************
      print*,'output file = ',fname
      call check_err90( NF90_CREATE(fname,NF90_CLOBBER,ncid) )

c********************* write out the global attributes: ************

      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'Conventions',
     &     'CF-1.0')
      call check_err90(iret)

      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'title',
c     &'Daily optimum interpolation(OI) SST: AVHRR only, Intrim V2')  
     &title)
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'History',
     &     'Version 2.0')
      call check_err90(iret)
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'creation_date',
     &     cnetdate)
      call check_err90(iret)
      
cliu      print*,'******************start coverage info********************'
cliu      print*, buoyship_cov
cliu       iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'buoy_ship_coverage',
cliu     &     buoyship_cov)
cliu      call check_err90(iret)
      
cliu      print*, sat_cov
cliu      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,
cliu     &     'NOAA19day_NOAA19nte_METOPday_METOPnte_coverage',
cliu     &     sat_cov)
cliu      call check_err90(iret)
      
cliu      print*, iceice_cov
cliu      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'ice_coverage',
cliu     &     iceice_cov)
cliu      call check_err90(iret)
      
cliu      print*,'******************end coverage info*********************'
      
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'Description',
     & 'Reynolds, et al.(2007) Daily High-resolution Blended Analyses. A 
     &vailable at ftp://eclipse.ncdc.noaa.gov/pub/OI-daily/daily-sst.pdf
     &  Climatology is based on 1971-2000 OI.v2 SST, Satellite data: Nav
     &y NOAA18 METOP AVHRR, Ice data: NCEP ice')
       
     
      call check_err90(iret)

c      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'Documentation',
c     & 'http://ncdc.noaa.gov/oa/climate/research/sst/OI_daily.php')
c      call check_err90(iret)
 
      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'Source',
     &     'NOAA/National Climatic Data Center')
      call check_err90(iret)

      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'Contact',
     &     'Dick Reynolds, email: Richard.W.Reynolds@noaa.gov & Chunying
     & Liu, email: Chunying.liu@noaa.gov')
      call check_err90(iret)
     
c      iret = NF90_PUT_ATT(ncid,NF90_GLOBAL,'netcdf_Convention',
c     &     'COARDS')
c      call check_err90(iret)  

c********************* end of global attributes: ***************************
              
C     call out dimension IDs w/ error checks:
      
      call check_err90( nf90_def_dim(ncid,'time',time_nr,timeDimID) )
      call check_err90( nf90_def_dim(ncid,'zlev',zlev_len,zlevDimID))      
      call check_err90( nf90_def_dim(ncid,'lat',lat_len,latDimID) )
      call check_err90( nf90_def_dim(ncid,'lon',lon_len,lonDimID) )
      
      
c      call check_err90( nf90_def_dim(ncid,'time',NF90_UNLIMITED,
c     &							timeDimID) )

     
C     call out variables IDs & assign attributes:
      !call put variable IDs:
      iret = nf90_def_var(ncid, 'time',NF90_REAL,timeDimID,timeID)
      					call check_err90(iret)
      iret = nf90_def_var(ncid,'zlev',NF90_REAL,zlevDimID,zlevID)
      					call check_err90(iret)					
      iret = nf90_def_var(ncid,'lat',NF90_REAL,latDimID,latID)
      					call check_err90(iret)
      iret = nf90_def_var(ncid,'lon',NF90_REAL,lonDimID,lonID)
      					call check_err90(iret)           
					
      					sstDimIDs(4) = timeDimID
					sstDimIDs(3) = zlevDimID
      					sstDimIDs(2) = latDimID
      					sstDimIDs(1) = lonDimID
      iret = nf90_def_var( ncid,'sst',NF90_SHORT,sstDimIDs,sstID)
					call check_err90(iret)
					
					anomDimIDs(4) = timeDimID
					anomDimIDs(3) = zlevDimID					
					anomDimIDs(2) = latDimID
      					anomDimIDs(1) = lonDimID
      iret = nf90_def_var(ncid,'anom',NF90_SHORT,anomDimIDs,anomID)
					call check_err90(iret)	
					
					errDimIDs(4) = timeDimID
					errDimIDs(3) = zlevDimID
					errDimIDs(2) = latDimID
      					errDimIDs(1) = lonDimID
      iret = nf90_def_var(ncid,'err',NF90_SHORT,errDimIDs,errID)
					call check_err90(iret)
					
					iceDimIDs(4) = timeDimID
					iceDimIDs(3) = zlevDimID
					iceDimIDs(2) = latDimID
      					iceDimIDs(1) = lonDimID
      iret = nf90_def_var(ncid,'ice',NF90_SHORT,iceDimIDs,iceID)
					call check_err90(iret)
					
c******************************************************************      
      !Assign attributes:
      iret = nf90_put_att(ncid, latID, 'long_name','Latitude')
      iret = nf90_put_att(ncid, latID, 'units', 'degrees_north')
      					call check_err90(iret)    
      iret = nf90_put_att(ncid, latID, 'grids', 
     &             'Uniform grid from -89.875 to 89.875 by 0.25')
      					call check_err90(iret)    

      iret = nf90_put_att(ncid, lonID, 'long_name','Longitude')
      iret = nf90_put_att(ncid, lonID, 'units', 'degrees_east')
     					call check_err90(iret)
      iret = nf90_put_att(ncid, lonID, 'grids', 
     &             'Uniform grid from 0.125 to 359.875 by 0.25')
      					call check_err90(iret)    

      iret = nf90_put_att(ncid, zlevID, 'long_name', 
     &                              'Sea surface height')
     					call check_err90(iret)
      iret = nf90_put_att(ncid, zlevID, 'units', 'meters')
     					call check_err90(iret)
	
      iret = nf90_put_att(ncid, zlevID, 'actual_range', '0, 0')
     					call check_err90(iret)				

      iret = nf90_put_att(ncid, timeID, 'long_name',
     &                    'Center time of the day')
      print*,'sdate:',sdate
      timeunit='days since '//refdate
      iret = nf90_put_att(ncid, timeID, 'units',timeunit)
      					call check_err90(iret)
c      iret = nf90_put_att(ncid, timeID, 'actual_range','0, 23')
c      					call check_err90(iret)
					
      offset=0.0
      scale=0.01
      min=-300
      max=4500					
					
     			
      iret = nf90_put_att(ncid, sstID, 'long_name', 
     &   'Daily sea surface temperature')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'units', 'degrees C')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, '_FillValue', fillval)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'add_offset', offset)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'scale_factor', scale)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'valid_min', min)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, sstID, 'valid_max', max)
      					call check_err90(iret)
	
      min=-1200
      max=1200							
     			
      iret = nf90_put_att(ncid, anomID, 'long_name', 
     &   'Daily sea surface temperature anomalies')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, anomID, 'units', 'degrees C')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, anomID, '_FillValue', fillval)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, anomID, 'add_offset', offset)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, anomID, 'scale_factor', scale)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, anomID, 'valid_min', min)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, anomID, 'valid_max', max)
      					call check_err90(iret)				
      min=0
      max=1000		
      				
      iret = nf90_put_att(ncid, errID, 'long_name', 
     &   'Estimated error standard deviation of analysed_sst')      
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'units', 'degrees C')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, '_FillValue', fillval)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'add_offset', offset)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'scale_factor', scale)				
					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'valid_min', min)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, errID, 'valid_max', max)
      					call check_err90(iret)				
      min=0
      max=100				
					
      iret = nf90_put_att(ncid, iceID, 'long_name', 
     &   'Sea ice concentration')     
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'units', 'percentage')
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, '_FillValue', fillval)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'add_offset', offset)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'scale_factor', scale)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'valid_min', min)
      					call check_err90(iret)
      iret = nf90_put_att(ncid, iceID, 'valid_max', max)
      					call check_err90(iret)	
					
   
C     leave define mode
      call check_err90( NF90_ENDDEF(ncid) )

C     store time:
c      time(1)=1
      call check_err90( nf90_put_var(ncid, timeID, time) )
  
C     store lat:
      do ic=1,lat_len
          lat(ic)= -89.875+(ic-1)*0.25
      enddo
      call check_err90( nf90_put_var(ncid, latID, lat) )
    
C     store lon
      do ic=1,lon_len
          lon(ic)= 0.125+(ic-1)*0.25
      enddo
      call check_err90( nf90_put_var(ncid, lonID, lon) )

C     store zlev
      call check_err90( nf90_put_var(ncid, zlevID, zlev) )

C     store sst
      call check_err90( nf90_put_var(ncid, sstID, sst) )
      call check_err90( nf90_put_var(ncid, anomID, anom) )
      call check_err90( nf90_put_var(ncid, errID, err) )
      call check_err90( nf90_put_var(ncid, iceID, ice) )
   
c*********************** close out the nc file:
      call check_err90( nf90_close(ncid) )	! close output file

      return
      end
