ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c    Generate FR file for ghrsst 
c    cdate   - daily OI SST date, usually is one day before the processing day
c    ccdate  - one day delay of OI SST date  
c    cnetdate - FR created data                             
c                                                                                   
c   output files:  FR-yyyymmdd--NCDC-L4LRblend-GLOB-v01-fv01_0-AVHRR_OI.xml         
c                                                                                   
c      August 2008  chunying Liu                                                    
c                                                                                   
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       CHARACTER*8 cdate, ccdate,cnetdate
       CHARACTER*10 rnetdate
       character*100 frpath
       
       data frpath(1:45)          
     1/'/raid2/sstday/yyyy/netcdf/GHRSST/AVHRR_intv2/'/
       data frpath(46:100)
     1/'FR-yyyymmdd-NCDC-L4LRblend-GLOB-v01-fv02_0-AVHRR_OI.xml'/  
     
       print*,frpath
       
       read *, iyrs, imos, idas, iyre, imoe, idae
       print*, 'start year, month, day :', iyrs, imos, idas
       print*, 'end year, month, day :  ', iyre, imoe, idae
       
       read*, netiyr,netmon,netday
       print*, 'NetCDF create year, month,day: ', netiyr,netmon,netday
       
       write (rnetdate,'(i4.4,a1,i2.2,a1,i2.2)') 
     1        netiyr,'-',netmon,'-',netday 
       print*,'FR first created date: ',rnetdate
       
       write (cnetdate,'(i4.4,i2.2,i2.2)') 
     1        netiyr,netmon,netday 
       print*,'NetCDF create date: ',rnetdate
       
       IJds = iw3jdn(iyrs,imos,idas)
       IJde = iw3jdn(iyre,imoe,idae)
       print 201,iyrs,imos,idas,ijds
  201  format ('START: year =',i5,3x,'month =',i3,3x,'day =',i3,3x,
     1 'jday =',i8)
       print 202,iyre,imoe,idae,ijde
  202  format (' END: year =',i5,3x,'month =',i3,3x,'day =',i3,3x,
     1 'jday =',i8)

       do ijd=ijds,ijde
       call W3FS26(ijd,iyr,imo,ida,idawk,idayr) 
c       print*,' analysis date:',iyr,imo,ida
      
       write (cdate,'(i4.4,i2.2,i2.2)') iyr,imo,ida 
       print*,cdate 
       
       ijd2=ijd+1
       call W3FS26(ijd2,iyr2,imo2,ida2,idawk2,idayr2) 
       write (ccdate,'(i4.4,i2.2,i2.2)') iyr2,imo2,ida2     
c       print*,ccdate
       
       
       write (frpath(15:18),'(i4.4)') iyr
       write (frpath(49:56),'(i4.4,i2.2,i2.2)') iyr,imo,ida
       print*,frpath
       
       open(51,file=frpath,form='formatted')
          
       write(51,*)'<?xml version="1.0" encoding="UTF-8"?>'
       write(51,*)'<!DOCTYPE MMR_FR SYSTEM "mmr_fr.dtd">'
       write(51,*)'<MMR_FR>'
       write(51,*)'<Entry_ID>NCDC-L4LRblend-GLOB-AVHRR_OI</Entry_ID>'
       write(51,*)'<File_Name>',cdate,
     1      '-NCDC-L4LRblend-GLOB-v01-fv02_0-AVHRR_OI.nc</File_Name>'
       write(51,*)'<File_Release_Date>',cnetdate,
     1            'T000000Z</File_Release_Date>'
       write(51,*)'<File_Version>2.0</File_Version>'
       write(51,*)'<Related_URL>'
       write(51,*)'<URL>http://http://www.ncdc.noaa.gov/oa/climate/'//
     1            'research/sst/oi-daily.php</URL>'
       write(51,*)'<Description>Home page for NOAA Daily OI SST '//
     1            'with access to data and documentation.</Description>'
       write(51,*)'</Related_URL>'
       write(51,*)'<Temporal_Coverage>'
       write(51,*)'<Start_Date>',cdate,'T000000Z</Start_Date>'
       write(51,*)'<Stop_Date>',ccdate,'T000000Z</Stop_Date>'
       write(51,*)'</Temporal_Coverage>'
       write(51,*)'<Spatial_Coverage>'
       write(51,*)'<Southernmost_Latitude> -90.00'//
     1            '</Southernmost_Latitude>'
       write(51,*)'<Northernmost_Latitude>  90.00'//
     1            '</Northernmost_Latitude>'
       write(51,*)'<Westernmost_Longitude>-180.00'//
     1            '</Westernmost_Longitude>'
       write(51,*)'<Easternmost_Longitude> 180.00'//
     1            '</Easternmost_Longitude>'
       write(51,*)'</Spatial_Coverage>'
       write(51,*)'<Personnel>'
       write(51,*)'<Role>Technical Contact</Role>'
       write(51,*)'<First_Name>Chunying</First_Name>'
       write(51,*)'<Last_Name>Liu</Last_Name>'
       write(51,*)'<Email>Chunying.Liu@noaa.gov</Email>'
       write(51,*)'<Phone>+01 828 350 2409</Phone>'
       write(51,*)'<Fax>+01 828 271 4328</Fax>'
       write(51,*)'<Address>NOAA National Climatic Data Center,'//
     1    ' 151 Patton Ave., Asheville, NC 28801-5001, USA</Address>'
       write(51,*)'</Personnel>'
       write(51,*)'<Metadata_History>'
       write(51,*)'<FR_File_Version>2.0</FR_File_Version>'
       write(51,*)'<FR_Creation_Date>',cnetdate,
     1            'T000000Z</FR_Creation_Date>'
       write(51,*)'<FR_Last_Revision_Date>',cnetdate,
     1            'T000000Z</FR_Last_Revision_Date>'
       write(51,*)'<FR_Revision_History>',rnetdate,
     1            ', First created.</FR_Revision_History>'
       write(51,*)'</Metadata_History>'
       write(51,*)'</MMR_FR>'
       end do
101    format(a39)
       print*,'GREEN-SUCCESSFUL! fr_navy_intv2.f'
       call exit(1)

       end
       
       include '/home/cliu/lib/w3lib/iw3jdn.f'
       include '/home/cliu/lib/w3lib/w3fs26.f'

