cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     oi_netcdf_navy_intv2_GHRSST.f
c     read daily OISST, landmask, ice write out in netcdf format
c     for GHRSST
c     Aug, 2008  Chunying Liu
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       PARAMETER (imx=1440,imy=720)        
       real sst(imx,imy),aice(imx,imy)
       real rsvar(imx,imy),bsvar(imx,imy)
       real sst_left(imy,imy),aice_left(imy,imy),ierr_left(imy,imy)
       real sst_right(imy,imy),aice_right(imy,imy),ierr_right(imy,imy)
       integer*2 isst(imx,imy),ierr(imx,imy)
       integer*1 ice(imx,imy)
       integer(kind=1) :: mask(imx,imy),ls(imx,imy)
       integer*2 undef2 
       integer*1 undef1 
       
       dimension cmask(imx,imy)       
       character*74 oipath,climpath*39,icepath*45
       character*48 icepath_ncep
       character*96 cdfpath
c       CHARACTER*8 TYPE
       CHARACTER*10 cdate, ccdate,cnetdate, refdate*99
       character title*80    
       logical lexist
c
       IYRref=1981	!reference year
       IMONref=1		!January
       IDAYref=1		
       write (refdate,'(i4.4,a1,i2.2,a1,i2.2,a9)') 
     &			IYRref,'-',IMONref,'-',IDAYref,' 00:00:00'
       print*,'refdate=',refdate
      
       data oipath (1:42)     
     1/'/raid2/sstday/yyyy/eotanal/navy1718-finv2/'/
       data oipath (43:74)
     2/'sst4-navy1718-eot-finv2.yyyymmdd'/
       print*,oipath
      
       data cdfpath(1:45)          
     1/'/raid2/sstday/yyyy/netcdf/GHRSST/AVHRR_finv2/'/
       data cdfpath(46:96)
     2/'yyyymmdd-NCDC-L4LRblend-GLOB-v01-fv02_0-AVHRR_OI.nc'/
       print*,cdfpath
              
       data climpath (1:39)
     1 /'/raid2/sstday/yyyy/clmoiv2/clmoiv2.mmdd'/
       print*,climpath
       
       data icepath (1:45)
     1 /'/raid2/sstday/yyyy/obs/gsfc-med/cice.yyyymmdd'/
       print*,icepath
       
       data icepath_ncep (1:48)
     1 /'/raid2/sstday/yyyy/grads/ice-med/icecon.yyyymmdd'/
       print*,icepath_ncep
            
      open (30,file='/raid2/sstday/clim/quarter-mask-extend',
     1 form='unformatted')

      undef = -9999.
c      undef2 = -9999
      undef2=-32768
      undef1=-128

      read (30) cmask
      call maxmin (cmask,imx,imy,undef,'land sea  ')
      call maxmin (cmask,imx,imy,1.,'land pts  ')
      call maxmin (cmask,imx,imy,0.,'ocean pts ')

c  land=0, sea=1, convert to land=2, sea=1
c  sea   1000   1 
c  land  0100   2
c  convert lon from 0E-360E to -180E-180E    
      do i=1,imx
        do j=1,imy
	
	  ls(i,j) = nint(cmask(i,j))
	  if(i.ge.721)then
	  ii=i-720
	  else
	  ii=i+720
	  endif
	  
	  if(ls(i,j) .eq. 0)then
	  mask(ii,j)=ls(i,j)+2
	  elseif(ls(i,j) .eq. 1)then
	  mask(ii,j)=ls(i,j)
	  else
	  mask(ii,j)=undef1
	  endif
	  
       enddo
      enddo          
 
c       iyrs = 2006
c       imos = 1
c       idas = 1
c       iyre = 2006
c       imoe = 12
c       idae = 31
       ix=0

       read *, iyrs, imos, idas, iyre, imoe, idae
       print*, 'start year, month, day :', iyrs, imos, idas
       print*, 'end year, month, day :  ', iyre, imoe, idae
       
       read*, netiyr,netmon,netday
       print*, 'NetCDF create year, month,day: ', netiyr,netmon,netday
       
       write (cnetdate,'(i4.4,a1,i2.2,a1,i2.2)') 
     1        netiyr,'-',netmon,'-',netday 
       print*,'NetCDF create date: ',cnetdate
      
       IJds = iw3jdn(iyrs,imos,idas)
       IJde = iw3jdn(iyre,imoe,idae)
       print 201,iyrs,imos,idas,ijds
  201  format ('START: year =',i5,3x,'month =',i3,3x,'day =',i3,3x,
     1 'jday =',i8)
       print 202,iyre,imoe,idae,ijde
  202  format (' END: year =',i5,3x,'month =',i3,3x,'day =',i3,3x,
     1 'jday =',i8)

       do 110 ijd=ijds,ijde
       call W3FS26(ijd,iyr,imo,ida,idawk,idayr) 
c       print*,' analysis date:',iyr,imo,ida
      
       write (cdate,'(i4.4,a1,i2.2,a1,i2.2)') iyr,'-',imo,'-',ida 
       print*,cdate 
       
       ijd2=ijd+1
       call W3FS26(ijd2,iyr2,imo2,ida2,idawk2,idayr2) 
       write (ccdate,'(i4.4,a1,i2.2,a1,i2.2)') iyr2,'-',imo2,'-',ida2     
c       print*,ccdate
       
       write (oipath(15:18),'(i4.4)') iyr
       write (oipath(67:74),'(i4.4,i2.2,i2.2)') iyr,imo,ida       
       
       write (climpath(15:18),'(i4.4)') iyr
       write (climpath(36:39),'(i2.2,i2.2)')imo,ida
       
       write (cdfpath(15:18),'(i4.4)') iyr
       write (cdfpath(46:53),'(i4.4,i2.2,i2.2)') iyr,imo,ida  

      
       if (ijd.eq.ijds.or.ijd.eq.ijde) then
        print *,'open = ',oipath
	print *,'open = ',climpath	
	print *,'open = ',cdfpath
       endif
      
       INQUIRE(FILE=oipath,EXIST=LEXIST)
       if(.not.lexist) then
         print *,'no more data: stop 1, unit = 11'
	 print *,' '
        go to 300
       endif  
      
       open (11,file=oipath,status='old',form='unformatted')
       ix=ix+1
            
       read (11,end=200) jyr,jmo,jda,sst 
       read (11,end=200) jyr,jmo,jda,rsvar
       read (11,end=200) jyr,jmo,jda,bsvar
       read (11,end=200) title
       print*,' SST date:',jyr,jmo,jda
c       print*,(sst(i,300),i=720,725)
       call maxmin (sst,imx,imy,undef,'sst     ')
       call maxmin (rsvar,imx,imy,undef,'rsvar   ')
       call maxmin (bsvar,imx,imy,undef,'bsvar   ')
       
c  convert lon from 0E-360E to -180E-180E
       sst_left=sst(1:720,1:imy)
       sst_right=sst(721:1440,1:imy)
       
       sst(721:1440,1:imy)=sst_left
       sst(1:720,1:imy)=sst_right
        
c  convert from float to integer
 
       do i=1,imx
       do j=1,imy
       if(sst(i,j) .eq. undef)then
       isst(i,j)=undef2
       else
c       isst(i,j)=100*(sst(i,j)+273.15)
       isst(i,j)=nint(100.0*sst(i,j))
       endif 
       enddo
       enddo
c       print*,isst(1:10,200:210)


c      analysis_error

        do i=1,imx
        do j=1,imy
        if (rsvar(i,j).ge.0.0 .and. bsvar(i,j).ge.0.0)then
        ierr(i,j) = nint(100.*sqrt(rsvar(i,j)+bsvar(i,j)))
	else
	ierr(i,j) = undef2
        endif
        enddo
        enddo 
   
       write(*,101)((ierr(i,j),j=300,300),i=720,725)
101    format(1x,6i10)

c  convert lon from 0E-360E to -180E-180E
       ierr_left=ierr(1:720,1:imy)
       ierr_right=ierr(721:1440,1:imy)
       
       ierr(721:1440,1:imy)=ierr_left
       ierr(1:720,1:imy)=ierr_right
       
c ice
       if(iyr .ge. 2005)then       
       write (icepath_ncep(15:18),'(i4.4)') iyr
       write (icepath_ncep(41:48),'(i4.4,i2.2,i2.2)') iyr,imo,ida
       print *,'open = ',icepath_ncep
       else
       write (icepath(15:18),'(i4.4)') iyr
       write (icepath(38:45),'(i4.4,i2.2,i2.2)') iyr,imo,ida
       print *,'open = ',icepath
       endif
       
       undef_ice=undef
       if(iyr .ge. 2005)then
c       undef_ice=-1E30
       
c  if there is no ice file available on the day. assign undef value and continue       
       INQUIRE(FILE=icepath_ncep,EXIST=LEXIST)
       if(.not.lexist) then
         print *,'no ice data (unit = 14)on day:', iyr,imo,ida 
	 print *,'assign ice = undef1 = -128'
	 ice(:,:) = undef1
        go to 333
       endif  
       
       open (14,file=icepath_ncep,status='old',form='unformatted')     
       read (14,end=200) iiyr,iimo,iida,aice 
c       print*,' ice date:',iiyr,iimo,iida
       call maxmin (aice,imx,imy,undef_ice,'aice    ')
       else
	       
c  if there is no ice file available on the day. assign undef value and continue       
       INQUIRE(FILE=icepath,EXIST=LEXIST)
       if(.not.lexist) then
         print *,'no ice data (unit = 14)on day:', iyr,imo,ida 
	 print *,'assign ice = undef1 = -128'
	 ice(:,:) = undef1
        go to 333
       endif  
       
       open (14,file=icepath,status='old',form='unformatted') 
       read (14,end=200) iiyr,iimo,iida,aice 
c       print*,' ice date:',iiyr,iimo,iida
       call maxmin (aice,imx,imy,undef_ice,'aice    ')
       endif
           
       

c  convert lon from 0E-360E to -180E-180E
       aice_left=aice(1:720,1:imy)
       aice_right=aice(721:1440,1:imy)
       
       aice(721:1440,1:imy)=aice_left
       aice(1:720,1:imy)=aice_right       
       
        WHERE (aice(:,:) == undef_ice)        
        ice(:,:) = undef1
        ELSEWHERE       
        ice(:,:)= nint(100.0*aice(:,:))
        END WHERE 
	
        
c       call maxmin (anom,imx,imy,undef,'err     ')

333       print*,''

       call imaxmin2 (isst,imx,imy,undef2,'isst    ')
       call imaxmin2 (ierr,imx,imy,undef2,'ierr    ')
       call imaxmin1 (ice,imx,imy,undef1,'ice     ')
       call imaxmin1 (mask,imx,imy,undef1,'mask      ')
       
       
c  write to netcdf
c      seconds from the reference day
       isecond = iw3jdn(iyr,imo,ida) - IW3JDN(IYRref,IMONref,IDAYref)
       isecond = 24*60*60*isecond
       print*,'second=',isecond
       
       call put_cdf_navy_finv2_GHRSST(cdfpath,isst,ierr,ice,mask,
     1          cnetdate, cdate,ccdate,refdate,isecond,title)      
      
       IF (iyr.ne.jyr.or.imo.ne.jmo.or.ida.ne.jda) THEN
        PRINT *,' WARNING DATE DO NOT MATCH: DATA NOT USED'
        print*,' analysis date:',iyr,imo,ida
        print*,'     data date:',jyr,jmo,jda
	go to 200
       endif
      
110    continue
300    print *,'Days written =',ix

       print*,'GREEN-SUCCESSFUL! oi_netcdf_navy_finv2_GHRSST.f'
       call exit (1)
      
200    PRINT 302
302    FORMAT (' WARNING! - PREMATURE END OF INPUT DATA: stop 100')
       call exit (100)  

       end
      
      
      
       subroutine maxmin (fld,im,jm,undef,name)
c
c   compute maximum, minium and average of fld and print
c
       dimension fld(im,jm)
       character*8 name
       real*8 ave,r
       fldmin = 1.e30
       fldmax = -fldmin
       inum = 0
       ave = 0.
       do 90 i=1,im
       do 90 j=1,jm
       if (fld(i,j).ne.undef) then
        inum = inum + 1
        ave = ave + fld(i,j)
        if (fldmin.gt.fld(i,j))  fldmin = fld(i,j)
        if (fldmax.lt.fld(i,j))  fldmax = fld(i,j) 
       endif
   90  continue
       if (inum.gt.0) then
        r = 1./float(inum)
        ave = ave*r
       else
        fldmin = 0.
        fldmax = 0.
       endif
       print 88,ave,fldmin,fldmax,inum,name
   88  format (' ave =',f10.3,2x,'min =',f10.3,2x,
     1 'max =',f10.3,2x,'inum =',i8,2x,a8)
       return 
       end
      
       include '/raid2/cliu/sstday/ftn/put_cdf_navy_finv2_GHRSST.f'
       include '/raid2/cliu/sstday/ftn/check_err90.f'
       include '/home/cliu/lib/w3lib/iw3jdn.f'
       include '/home/cliu/lib/w3lib/w3fs26.f'
       include '/home/cliu/lib/imaxmin2.f' 
       include '/home/cliu/lib/imaxmin1.f'
      
